------------------------------------------------------------
revno: 4585
tags: clone-mysql-5.1.63-ndb-7.1.23-src-build
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-06-28 16:49:16 -0700
message:
  Clean new clusterj table twopk
------------------------------------------------------------
revno: 4584
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-06-28 15:30:59 -0700
message:
  Bug 14248122: Tables without primary key throw NullPointerException instead of ClusterJUserException
  In theory, tables without a primary key can be used by mapping a field to the $PK column.
  A quick experiment showed that find and query works with a mapped $PK column but insert fails silently.
  If this feature is needed, more investigation will be required.
------------------------------------------------------------
revno: 4583
committer: magnus.blaudd@oracle.com
branch nick: 7.1
timestamp: Wed 2012-06-27 15:25:16 +0200
message:
  WL#6224 Adapt MySQL Cluster to 5.6
   - mysqltest's builtin command "system" is deprecated in the future,
     use "exec" to run our tool ndb_drop_table 
------------------------------------------------------------
revno: 4582
committer: magnus.blaudd@oracle.com
branch nick: 7.1
timestamp: Wed 2012-06-27 14:50:42 +0200
message:
  WL#6224 Adapt MySQL Cluster to 5.6
   - use memset() in favor of bzero in ha_ndbcluster
------------------------------------------------------------
revno: 4581 [merge]
committer: magnus.blaudd@oracle.com
branch nick: 7.1
timestamp: Tue 2012-06-26 16:22:21 +0200
message:
  Merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.41 [merge]
    tags: clone-mysql-5.1.63-ndb-7.0.34-src-build
    committer: magnus.blaudd@oracle.com
    branch nick: mysql-5.1-telco-7.0
    timestamp: Tue 2012-06-26 15:09:11 +0200
    message:
      Merge
        ------------------------------------------------------------
        revno: 3362.181.2
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Tue 2012-06-26 15:03:52 +0200
        message:
          Bug#11764570: NDB_ERROR_REPORTER ONLY COLLECTS LOGS MATCHING NAME
          NDB_$ID*.
           - Remove 'logger.log' as default filename from FileLogHandler
           - Require filename argument to Logger::createFileHandler() and always
             call FileLogHandler constructor with that name.
           - Move the addHandler function from Logger to MgmtSrvr thus making it
             significantly easier to pass the default cluster log filename for the
             current node to the FileLogHandler constructor.
           - Make ndb_error_reporter parse out filename=xxx from LogDestination
             and try to copy that file(can theoretically be more than one)
             as well from the remote host.
           - Add testcase making sure that ndb_mgmd does not create logger.log anymore
             but instead defaults to ndb_<nodeid>_cluster.log if LogDestination=FILE:
             has been used wiuthout filename= parameter
        ------------------------------------------------------------
        revno: 3362.181.1
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Tue 2012-06-26 13:21:25 +0200
        message:
          ndb
           - remove unused functions from LogHandler
------------------------------------------------------------
revno: 4580 [merge]
committer: Jan Wedvik <jan.wedvik@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Tue 2012-06-26 14:30:55 +0200
message:
  Merge 7.0->7.1
    ------------------------------------------------------------
    revno: 3362.176.40 [merge]
    committer: Jan Wedvik <jan.wedvik@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Tue 2012-06-26 14:28:59 +0200
    message:
      Merge 6.3->7.0
        ------------------------------------------------------------
        revno: 2585.188.4
        committer: Jan Wedvik <jan.wedvik@oracle.com>
        branch nick: mysql-5.1-telco-6.3
        timestamp: Tue 2012-06-26 14:26:28 +0200
        message:
          Fixing Windows build break.
------------------------------------------------------------
revno: 4579 [merge]
committer: Jan Wedvik <jan.wedvik@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Tue 2012-06-26 12:57:31 +0200
message:
  Merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.39 [merge]
    committer: Jan Wedvik <jan.wedvik@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Tue 2012-06-26 11:18:05 +0200
    message:
      Merge 6.3->7.0
        ------------------------------------------------------------
        revno: 2585.188.3
        committer: Jan Wedvik <jan.wedvik@oracle.com>
        branch nick: mysql-5.1-telco-6.3
        timestamp: Tue 2012-06-26 11:00:13 +0200
        message:
          Patch updated according to suggestions from Magnus Bl?udd and Fraqzer Clement.
          
          This is a fix for bug#11748194 "TRANSACTION OBJECT CREATED AND UNRELEASED BY 
          EXTRA CALL TO NEXTRESULT()".
          
          This bug had the following effect: If an API application tried calling 
          NdbScanOperation::nextResult() once more when the previous call had retuned
          end-of-file (return code 1), the api would leak a transaction object.
          
          This commit fixes that problem. Ndb::closeTransaction() will now put the
          extra transaction object associated with the scan back in the idle list
          for the right TC node.
          
          Also, calling NdbScanOperation::nextResult() once too much will now set
          a proper error code (4210), instead of the undefined code -1.
          
          Finally, this commit adds a regression test that will trigger the bug if the
          bugfix is not applied.
------------------------------------------------------------
revno: 4578 [merge]
committer: magnus.blaudd@oracle.com
branch nick: 7.1
timestamp: Mon 2012-06-25 15:01:40 +0200
message:
  Merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.38
    committer: magnus.blaudd@oracle.com
    branch nick: 7.0
    timestamp: Mon 2012-06-25 14:55:27 +0200
    message:
      ndb test
       - remove unused "own nodeid" argument from NdbConfig (and thus NdbBackup)
       constructor.
        - remove unneccessary confusing construct when trying to figure out which
        nodeid to pass
------------------------------------------------------------
revno: 4577 [merge]
committer: Jan Wedvik <jan.wedvik@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Mon 2012-06-25 13:27:47 +0200
message:
  Merge 7.0->7.1
    ------------------------------------------------------------
    revno: 3362.176.37 [merge]
    committer: Jan Wedvik <jan.wedvik@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Mon 2012-06-25 13:18:06 +0200
    message:
      Merge 6.3 -> 7.0.
        ------------------------------------------------------------
        revno: 2585.188.2
        committer: Jan Wedvik <jan.wedvik@oracle.com>
        branch nick: mysql-5.1-telco-6.3
        timestamp: Thu 2012-06-21 12:31:29 +0200
        message:
          This is a fix for bug#14208924 . It is based on an initial patch written by 
          Frazer Clement.
          
          If TC decides to abort a transaction in the 'prepared' state, it may leak 
          ApiConnectRecord objects that was allocated via Dbtc::seizeApiConnectCopy(). 
          These are normally released by Dbtc::sendApiCommit() followed by
          Dbtc::releaseApiConCopy(). If the transaction aborts, these methods are not 
          called.
          
          This patch fixes the above issue by checking if the ApiConnectRecord object
          has an apiCopyRecord when the transaction aborts. If so, the copy object is put
          back in the free list.
          
          The patch also adds a regression test case (using an error insert).
------------------------------------------------------------
revno: 4576 [merge]
committer: Mauritz Sundell <mauritz.sundell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-06-21 17:17:40 +0200
message:
  ndb - Merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.36 [merge]
    committer: Mauritz Sundell <mauritz.sundell@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Thu 2012-06-21 14:42:50 +0200
    message:
      ndb - increase of hashmap size and supporting 1024 partitions
      
      This increased the hashmap size from 240 to 3840 to ensure that we don't get unbalanced
      access to the partitions in a large cluster setup. Influenced performance at 16 nodes and
      beyond by a fairly significant factor.
      
      Part of Mikael Ronstroms "Patches used in benchmark tree with Intel"
        ------------------------------------------------------------
        revno: 3362.180.7
        committer: Mauritz Sundell <mauritz.sundell@oracle.com>
        branch nick: mysql-5.1-telco-7.0-hashmap
        timestamp: Thu 2012-06-21 14:38:01 +0200
        message:
          ndb - added a few static assert for some partitioning related defines
        ------------------------------------------------------------
        revno: 3362.180.6
        committer: Mauritz Sundell <mauritz.sundell@oracle.com>
        branch nick: mysql-5.1-telco-7.0-hashmap
        timestamp: Thu 2012-06-21 14:36:35 +0200
        message:
          ndb - increase hashmap-size to allow for 1024 partitions and more.
          
          the new hashmap-size is 3840
        ------------------------------------------------------------
        revno: 3362.180.5
        committer: Mauritz Sundell <mauritz.sundell@oracle.com>
        branch nick: mysql-5.1-telco-7.0-hashmap
        timestamp: Thu 2012-06-21 14:35:31 +0200
        message:
          ndb - changed calculation of array sizes used for fragmentation data.
        ------------------------------------------------------------
        revno: 3362.180.4
        committer: Mauritz Sundell <mauritz.sundell@oracle.com>
        branch nick: mysql-5.1-telco-7.0-hashmap
        timestamp: Thu 2012-06-21 14:33:15 +0200
        message:
          ndb - changed calculation of #pages needed for pack table.
        ------------------------------------------------------------
        revno: 3362.180.3
        committer: Mauritz Sundell <mauritz.sundell@oracle.com>
        branch nick: mysql-5.1-telco-7.0-hashmap
        timestamp: Thu 2012-06-21 14:29:21 +0200
        message:
          ndb - prepare code for more than 255 partitions
          
          use MAX_NDB_PARTITIONS.
          add error checks of #partitions.
          ensure 16bit are used for fragment-ids in places
          there only 8 bits are used.
        ------------------------------------------------------------
        revno: 3362.180.2
        committer: Mauritz Sundell <mauritz.sundell@oracle.com>
        branch nick: mysql-5.1-telco-7.0-hashmap
        timestamp: Thu 2012-06-21 14:26:14 +0200
        message:
          ndb - use NDB_DEFAULT_HASHMAP_BUCKETS instead of numeric constants
        ------------------------------------------------------------
        revno: 3362.180.1
        committer: Mauritz Sundell <mauritz.sundell@oracle.com>
        branch nick: mysql-5.1-telco-7.0-hashmap
        timestamp: Thu 2012-06-21 14:24:52 +0200
        message:
          ndb - rename NDB_DEFAULT_HASHMAP_BUCKTETS to NDB_DEFAULT_HASHMAP_BUCKETS
------------------------------------------------------------
revno: 4575 [merge]
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-06-21 12:11:31 +0200
message:
  Merge from 7.0
    ------------------------------------------------------------
    revno: 3362.176.35 [merge]
    committer: Martin Skold <Martin.Skold@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Thu 2012-06-21 12:07:37 +0200
    message:
      Merge from 6.3
        ------------------------------------------------------------
        revno: 2585.188.1
        committer: Martin Skold <Martin.Skold@oracle.com>
        branch nick: mysql-5.1-telco-6.3
        timestamp: Thu 2012-06-21 12:05:18 +0200
        message:
          Bug#12755722  61528: INNODB BACKEND CRASHES ON ALTER TABLE STATEMENT (MYSQL SERVER HAS GONE AWAY: implemented check for new field and added test case
------------------------------------------------------------
revno: 4574 [merge]
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-06-21 11:33:14 +0200
message:
  Merge from 7.0
    ------------------------------------------------------------
    revno: 3362.176.34 [merge]
    committer: Martin Skold <Martin.Skold@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Thu 2012-06-21 11:23:58 +0200
    message:
      Merge from 6.3
        ------------------------------------------------------------
        revno: 2585.187.12
        committer: Martin Skold <Martin.Skold@oracle.com>
        branch nick: mysql-5.1-telco-6.3
        timestamp: Thu 2012-06-21 09:52:13 +0200
        message:
          Bug#13824846  FRM FILES ARE CREATED FOR MYSQLD, BUT TABLE DOES NOT EXIST IN CLUSTER, implemented check for new field and added test case
------------------------------------------------------------
revno: 4573
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Fri 2012-06-15 11:14:25 +0200
message:
  Removed initial restart of cluster in ndb_reconnect test since it reverts backup_id causing other test cases to fail, drop table internally in ndb instead
------------------------------------------------------------
revno: 4572
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-06-14 14:39:01 +0200
message:
  Bug#13824846,Bug#14185126: Cleaning away stray files at server startup or at cluster reconnect (after restart): Regenerated test result since stray file is now always gone
------------------------------------------------------------
revno: 4571
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-06-14 13:48:36 +0200
message:
  Bug#13824846,Bug#14185126: Cleaning away stray files at server startup or at cluster reconnect (after restart)
------------------------------------------------------------
revno: 4570
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-06-14 13:44:50 +0200
message:
  WL#1735 Handler: "discover" database: publisized function make_db_list
------------------------------------------------------------
revno: 4569 [merge]
committer: magnus.blaudd@oracle.com
branch nick: 7.1
timestamp: Wed 2012-06-13 21:10:06 +0200
message:
  Merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.33
    committer: magnus.blaudd@oracle.com
    branch nick: 7.0
    timestamp: Wed 2012-06-13 20:49:49 +0200
    message:
      ndb
       - add #include of ndb_global.h in ha_ndbcluster.cc to get NDB_ARRAY_SIZE and
       MIN/MAX
------------------------------------------------------------
revno: 4568 [merge]
committer: magnus.blaudd@oracle.com
branch nick: 7.1
timestamp: Wed 2012-06-13 20:36:43 +0200
message:
  Merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.32 [merge]
    committer: magnus.blaudd@oracle.com
    branch nick: mysql-5.1-telco-7.0
    timestamp: Wed 2012-06-13 19:40:40 +0200
    message:
      Merge
        ------------------------------------------------------------
        revno: 3362.179.6
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Wed 2012-06-13 19:36:47 +0200
        message:
          ndb
           - remove dead code for LOCK TABLES
        ------------------------------------------------------------
        revno: 3362.179.5
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Tue 2012-06-12 20:23:54 +0200
        message:
          WL#6223 Cluster zerodiff
           - Move rpl_multi_engine2.inc file down into suite/ndb_rpl since that is
             the only place where it's used
        ------------------------------------------------------------
        revno: 3362.179.4
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Tue 2012-06-12 18:10:00 +0200
        message:
          WL#6224 Adapt MySQL Cluster to 5.6
           - New behaviuor of TIMESTAMP columns which changes in the future
             and uses CURRENT_TIMSTAMP(as expected by DEFAULT CURRENT_TIMESTAMP) instead
             of 0000-00-00 00:00:00
           - Make test output from ndb_rpl_dd_advance consistent by saving the TIMESTAMP
             value of column c4 in order to be able to mask the value in later SELECTs
        ------------------------------------------------------------
        revno: 3362.179.3
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Mon 2012-06-11 12:35:38 +0200
        message:
          ndb
           - remove unused #include
        ------------------------------------------------------------
        revno: 3362.179.2
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Mon 2012-06-11 12:23:01 +0200
        message:
          ndb
           - Add two new ndbcluster variables exposing the version of NDB
             which ndbcluster was compiled against.
           - ndb_version contains the composite version number
           - ndb_version_string contains a version string on the form ndb-Y.Y.Y[-status]
           - These variables are primarily useful when masking .result files but just
             as well be useful in debugging and writing applications for multiple
             versions of MySQl Cluster
           - Added new macro(s) to ndb_version.h which concats the version numbers
             for NDB into constant strings so it can be used without thread
             synchronization problems(like ndbGetOwnVersionString()).
        ------------------------------------------------------------
        revno: 3362.179.1
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Fri 2012-06-08 09:53:18 +0200
        message:
          WL#6224 Adapt MySQL Cluster to 5.6
           -Fixed problem with ndb_alter_table_online by adding a "DEFAULT 0" to the new
           timestamp column, thus giving it a consistent value also in future versions
    ------------------------------------------------------------
    revno: 3362.176.31
    committer: Craig L Russell <Craig.Russell@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Wed 2012-06-13 05:28:41 -0700
    message:
      Fix stray backtick
    ------------------------------------------------------------
    revno: 3362.176.30
    committer: Craig L Russell <Craig.Russell@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Wed 2012-06-13 05:11:38 -0700
    message:
      Improve documentation of NdbScanOperation.hpp
------------------------------------------------------------
revno: 4567
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Mon 2012-06-11 14:57:45 -0700
message:
  QueryUniqueKeyTest is still causing ndbd to crash in 7.1 but not in 7.2
------------------------------------------------------------
revno: 4566
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Mon 2012-06-11 13:03:24 -0700
message:
  Re-enable clusterj QueryUniqueKeyTest after changes to scan flags
------------------------------------------------------------
revno: 4565 [merge]
committer: Mauritz Sundell <mauritz.sundell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Mon 2012-06-11 16:47:18 +0200
message:
  Merge 7.0->7.1
    ------------------------------------------------------------
    revno: 3362.176.29
    committer: Mauritz Sundell <mauritz.sundell@oracle.com>
    branch nick: mysql-5.1-telco-7.0-pushed
    timestamp: Mon 2012-06-11 15:30:32 +0200
    message:
      ndb - flexAsynch
      
      The revised flexAsynch program used in Mikael Ronstroms benchmarks,
      spring 2012.
      
      Part of Mikael Ronstroms "Patches used in benchmark tree with Intel"
    ------------------------------------------------------------
    revno: 3362.176.28
    committer: Mauritz Sundell <mauritz.sundell@oracle.com>
    branch nick: mysql-5.1-telco-7.0-pushed
    timestamp: Mon 2012-06-11 15:20:48 +0200
    message:
      ndb - NdbSleep_MicroSleep
      
      Added sleep function with microseconds resolution.
      Uses waitable timer in windows and nanosleep in posix, as
      fallback it rounds up to milliseconds and uses
      NdbSleep_MilliSleep
    ------------------------------------------------------------
    revno: 3362.176.27
    committer: Mauritz Sundell <mauritz.sundell@oracle.com>
    branch nick: mysql-5.1-telco-7.0-pushed
    timestamp: Thu 2012-06-07 16:49:35 +0200
    message:
      ndb - fifo idle connection list
      
      This ensures that the list of connections to the TC block is kept in a FIFO queue rather than a
      LIFO queue. Using a LIFO queue gave very unbalanced accesses to the TC blocks, there could
      be as much as a 10x difference between the different TC blocks in a node.
      
      Part of Mikael Ronstroms "Patches used in benchmark tree with Intel"
    ------------------------------------------------------------
    revno: 3362.176.26
    committer: Mauritz Sundell <mauritz.sundell@oracle.com>
    branch nick: mysql-5.1-telco-7.0-pushed
    timestamp: Thu 2012-06-07 16:46:55 +0200
    message:
      ndb - slowdown scans
      
      Invokes slowdown of scans when we reach 60% fill level instead of at blocking level at
      75% where primary key access is even stoppped (this is fill level of send buffer).
      
      Part of Mikael Ronstroms "Patches used in benchmark tree with Intel"
    ------------------------------------------------------------
    revno: 3362.176.25
    committer: Mauritz Sundell <mauritz.sundell@oracle.com>
    branch nick: mysql-5.1-telco-7.0-pushed
    timestamp: Thu 2012-06-07 16:06:59 +0200
    message:
      ndb - refactoring, rename of block variable
      
      Variables declared in for loop header should be
      assumed to be in same scope as loop body.
      And so names of variables declared in loop header
      should not be reused in loop body.
      This is detected in gcc47 but not in earlier gcc-versions.
------------------------------------------------------------
revno: 4564
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Sun 2012-06-10 14:08:50 -0700
message:
  Add ScanFlag.SF_OrderBy to descending order scans
------------------------------------------------------------
revno: 4563
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Sun 2012-06-10 13:51:00 -0700
message:
  Improve clusterj-unit TestCase error reporting to include test case and test method.
  Fix ordered multi-range scan by including ScanFlag.SF_ReadRangeNo in scan flags.
  Remember index used for index scans for better logging.
------------------------------------------------------------
revno: 4562
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Sat 2012-06-09 14:24:17 -0700
message:
  Re-enable ordering and limits test (keep unique key test disabled due to crash in ndbd
------------------------------------------------------------
revno: 4561 [merge]
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1_merge
timestamp: Thu 2012-06-07 14:07:59 +0200
message:
  Merge from 7.0
    ------------------------------------------------------------
    revno: 3362.176.24
    committer: Martin Skold <Martin.Skold@oracle.com>
    branch nick: mysql-5.1-telco-7.0_merge
    timestamp: Thu 2012-06-07 13:57:33 +0200
    message:
      Regenerated result for mysqldump, default character_set and collation now uses utf8
------------------------------------------------------------
revno: 4560 [merge]
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1_merge
timestamp: Thu 2012-06-07 12:58:14 +0200
message:
  Merge from 7.0 (5.1.63)
    ------------------------------------------------------------
    revno: 3362.176.23 [merge]
    committer: Martin Skold <Martin.Skold@oracle.com>
    branch nick: mysql-5.1-telco-7.0_merge
    timestamp: Thu 2012-06-07 11:06:47 +0200
    message:
      Merge from 5.1.63
        ------------------------------------------------------------
        revno: 2555.949.37 [merge]
        tags: mysql-5.1.63, clone-5.1.63-build
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Tue 2012-04-10 14:21:57 +0300
        message:
          merge mysql-5.1->mysql-5.1-security
            ------------------------------------------------------------
            revno: 2555.937.139
            committer: Venkata Sidagam <venkata.sidagam@oracle.com>
            branch nick: mysql-5.1-59107
            timestamp: Mon 2012-04-09 16:42:41 +0530
            message:
              Bug #11766072 59107: MYSQLSLAP CRASHES IF STARTED WITH NO ARGUMENTS ON WINDOWS
              
              This bug is a duplicate of Bug #31173, which was pushed to the 
              mysql-trunk 5.6 on 4th Aug, 2010. This is just a back-port of 
              the fix
            ------------------------------------------------------------
            revno: 2555.937.138
            committer: Mayank Prasad <mayank.prasad@oracle.com>
            branch nick: 5.1
            timestamp: Fri 2012-04-06 17:03:13 +0530
            message:
              BUG#13738989 : 62136 : FAILED TO FETCH SELECT RESULT USING EMBEDDED MYSQLD
              
              Background : 
              In mysql-5.1, in a fix for bug#47485, code has been changed for 
              mysql client (libmysql/libmysql.c) but corresponding code was not
              changed for embedded mysql. In that code change, after execution
              of a statement, mysql_stmt_store_result() checks for mysql->state
              to be MYSQL_STATUS_STATEMENT_GET_RESULT, instead of
              MYSQL_STATUS_GET_RESULT (earlier).
              
              Reason:
              In embedded mysql code, after execution, mysql->state was not
              set to MYSQL_STATUS_STATEMENT_GET_RESULT, so it was throwing
              OUT_OF_SYNC error.
              
              Fix:
              Fixed the code in libmysqld/lib_sql.cc to have mysql->state
              to be set to MYSQL_STATUS_STATEMENT_GET_RESULT after execution.
            ------------------------------------------------------------
            revno: 2555.937.137
            committer: Praveenkumar Hulakund <praveenkumar.hulakund@oracle.com>
            branch nick: mysql_5_1
            timestamp: Wed 2012-03-28 12:05:31 +0530
            message:
              Bug#11763507 - 56224: FUNCTION NAME IS CASE-SENSITIVE
              
              Analysis:
              -------------------------------
              According to the Manual
              (http://dev.mysql.com/doc/refman/5.1/en/identifier-case-sensitivity.html):
              "Column, index, stored routine, and event names are not case sensitive on any
              platform, nor are column aliases."
              
              In other words, 'lower_case_table_names' does not affect the behaviour of 
              those identifiers.
              
              On the other hand, trigger names are case sensitive on some platforms,
              and case insensitive on others. 'lower_case_table_names' does not affect
              the behaviour of trigger names either.
              
              The bug was that SHOW statements did case sensitive comparison
              for stored procedure / stored function / event names.
              
              Fix:
              Modified the code so that comparison in case insensitive for routines 
              and events for "SHOW" operation.
              
              As part of this commit, only fixing the test failures due to the actual code fix.
            ------------------------------------------------------------
            revno: 2555.937.136 [merge]
            committer: Sunny Bains <Sunny.Bains@Oracle.Com>
            branch nick: 5.1
            timestamp: Wed 2012-03-28 13:35:44 +1100
            message:
              Merge from mysql-5.0
                ------------------------------------------------------------
                revno: 1810.3999.22
                committer: Sunny Bains <Sunny.Bains@Oracle.Com>
                branch nick: mysql-5.0
                timestamp: Wed 2012-03-28 13:08:25 +1100
                message:
                  Bug# 13847885 - PURGING STALLS WHEN PURGE_SYS->N_PAGES_HANDLED OVERFLOWS
                  
                  Change the type of purge_sys_t::n_pages_handled and purge_sys_t::handle_limit
                  to ulonglong from ulint. On a 32 bit system doing ~700 deletes per second the
                  counters can overflow in ~3.5 months, if they are 32 bit.
                  
                  Approved by Jimmy Yang over IM.
            ------------------------------------------------------------
            revno: 2555.937.135
            committer: Tor Didriksen <tor.didriksen@oracle.com>
            branch nick: 5.1
            timestamp: Tue 2012-03-27 14:39:27 +0200
            message:
              Backport of fix for Bug#12763207 - ASSERT IN SUBSELECT::SINGLE_VALUE_TRANSFORMER
            ------------------------------------------------------------
            revno: 2555.937.134
            committer: Praveenkumar Hulakund <praveenkumar.hulakund@oracle.com>
            branch nick: mysql_5_1
            timestamp: Tue 2012-03-27 12:42:11 +0530
            message:
              Bug#11763507 - 56224: FUNCTION NAME IS CASE-SENSITIVE
              
              Analysis:
              -------------------------------
              According to the Manual
              (http://dev.mysql.com/doc/refman/5.1/en/identifier-case-sensitivity.html):
              "Column, index, stored routine, and event names are not case sensitive on any
              platform, nor are column aliases."
              
              In other words, 'lower_case_table_names' does not affect the behaviour of 
              those identifiers.
              
              On the other hand, trigger names are case sensitive on some platforms,
              and case insensitive on others. 'lower_case_table_names' does not affect
              the behaviour of trigger names either.
              
              The bug was that SHOW statements did case sensitive comparison
              for stored procedure / stored function / event names.
              
              Fix:
              Modified the code so that comparison in case insensitive for routines 
              and events for "SHOW" operation.
        ------------------------------------------------------------
        revno: 2555.949.36
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: B13934049-5.1-security
        timestamp: Fri 2012-04-06 12:04:07 +0300
        message:
          Bug #13934049: 64884: LOGINS WITH INCORRECT PASSWORD ARE ALLOWED
          
          Fixed an improper type conversion on return that can make the server accept
          logins with a wrong password.
        ------------------------------------------------------------
        revno: 2555.949.35
        committer: Sergey Glukhov <sergey.glukhov@oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Wed 2012-04-04 13:29:45 +0400
        message:
          Bug#11766300 59387: FAILING ASSERTION: CURSOR->POS_STATE == 1997660512 (BTR_PCUR_IS_POSITIONE
          Bug#13639204 64111: CRASH ON SELECT SUBQUERY WITH NON UNIQUE INDEX
          The crash happened due to wrong calculation
          of key length during creation of reference for
          sort order index. The problem is that
          keyuse->used_tables can have OUTER_REF_TABLE_BIT enabled
          but used_tables parameter(create_ref_for_key() func) does
          not have it. So key parts which have OUTER_REF_TABLE_BIT
          are ommited and it could lead to incorrect key length
          calculation(zero key length).
        ------------------------------------------------------------
        revno: 2555.949.34 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Wed 2012-03-21 14:58:27 +0200
        message:
          empty weave merge mysql-5.0-security->mysql-5.1-security
            ------------------------------------------------------------
            revno: 1810.4002.37 [merge]
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: merge-5.0-security
            timestamp: Wed 2012-03-21 14:35:25 +0200
            message:
              weave merge mysql-5.0->mysql-5.0-security
        ------------------------------------------------------------
        revno: 2555.949.33 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Wed 2012-03-21 14:53:09 +0200
        message:
          merge mysql-5.1->mysql-5.1-security
            ------------------------------------------------------------
            revno: 2555.937.133 [merge]
            committer: Joerg Bruehe <joerg.bruehe@oracle.com>
            branch nick: mysql-5.1
            timestamp: Wed 2012-03-21 11:18:21 +0100
            message:
              Upmerge an empty merge changeset (backmerge of 5.0.96 into main 5.0),
              solve a conflict in ".bzr-mysql/default.conf".
                ------------------------------------------------------------
                revno: 1810.3999.21 [merge]
                author: karen.langford@oracle.com
                committer: hery.ramilison@oracle.com
                branch nick: mysql-5.0
                timestamp: Tue 2012-03-20 17:30:49 +0100
                message:
                  Merge from mysql-5.0.96-release
            ------------------------------------------------------------
            revno: 2555.937.132 [merge]
            author: karen.langford@oracle.com
            committer: hery.ramilison@oracle.com
            branch nick: mysql-5.1
            timestamp: Tue 2012-03-20 17:35:41 +0100
            message:
              Merge from mysql-5.1.62-release
                ------------------------------------------------------------
                revno: 2555.960.3 [merge]
                tags: mysql-5.1.62
                committer: Joerg Bruehe <joerg.bruehe@oracle.com>
                branch nick: clone-5.1
                timestamp: Fri 2012-03-02 13:18:12 +0100
                message:
                  Upmerge the yaSSL upgrade (to 2.2.0) from MySQL 5.0 to 5.1.
                    ------------------------------------------------------------
                    revno: 1810.4005.2
                    tags: mysql-5.0.96
                    committer: Joerg Bruehe <joerg.bruehe@oracle.com>
                    branch nick: clone-5.0
                    timestamp: Fri 2012-03-02 13:12:07 +0100
                    message:
                      Further upgrade the yaSSL library to version 2.2.0
                      to pick up some new security fixes that are in it.
                      
                      Patch provided by Georgi Kodinov.
                ------------------------------------------------------------
                revno: 2555.960.2
                committer: Karen Langford <karen.langford@oracle.com>
                branch nick: mysql-5.1.62-release
                timestamp: Tue 2012-02-28 17:20:30 +0100
                message:
                  AIX builds fail for comments using //
                ------------------------------------------------------------
                revno: 2555.960.1 [merge]
                committer: Joerg Bruehe <joerg.bruehe@oracle.com>
                branch nick: clone-5.1
                timestamp: Tue 2012-02-28 12:44:21 +0100
                message:
                  Upmerge the copyright year change, from 5.0 to 5.1.
                    ------------------------------------------------------------
                    revno: 1810.4005.1
                    committer: Joerg Bruehe <joerg.bruehe@oracle.com>
                    branch nick: clone-5.0
                    timestamp: Tue 2012-02-28 12:42:02 +0100
                    message:
                      The current year is 2012, and nobody noticed ...
                      Update the year in the copyright notice, file "README".
            ------------------------------------------------------------
            revno: 2555.937.131
            committer: Annamalai Gurusami <annamalai.gurusami@oracle.com>
            branch nick: mysql-5.1-bug11766634
            timestamp: Fri 2012-03-16 12:06:29 +0530
            message:
              Bug #11766634 59783: INNODB DATA GROWS UNEXPECTEDLY WHEN INSERTING, TRUNCATING, INSERTING THE
              
              The test case must insert all the records using a single transaction. Otherwise the test 
              case takes more than 15 minutes and will time out in pb2 and mtr.  
            ------------------------------------------------------------
            revno: 2555.937.130
            committer: Inaam Rana <inaam.rana@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-03-15 13:30:17 -0400
            message:
              Bug#13825266 RACE IN LOCK_VALIDATE() WHEN ACCESSING PAGES DIRECTLY
              FROM BUFFER POOL
              
              rb://975
              approved by: Marko Makela
              
              There is a race in lock_validate() where we try to access a page
              without ensuring that the tablespace stays valid during the operation
              i.e.: it is not deleted. This patch tries to fix that by using an
              existing flag (the flag is renamed to make it's name more generic
              in line with it's new use).
            ------------------------------------------------------------
            revno: 2555.937.129
            committer: Inaam Rana <inaam.rana@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-03-15 12:38:40 -0400
            message:
              Bug#13851171 STRING OVERFLOW IN INNODB CODE FOUND BY STATIC ANALYSIS
              
              rb://976
              approved by: Marko Makela
              
              Add an assertion to ensure that string overflow is not happening.
              Pointed by Coverity analysis.
            ------------------------------------------------------------
            revno: 2555.937.128
            committer: Inaam Rana <inaam.rana@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-03-15 11:53:30 -0400
            message:
              Bug#13537504 VALGRIND: COND. JUMP/MOVE DEPENDS ON UNINITIALISED VALUES
              IN OS_THREAD_EQ
              
              rb://977
              approved by: Marko Makela
              
              rw_lock::writer_thread field contains the thread id of current x-holder
              or wait-x thread. This field is un-initialized at lock creation and is
              written to for the first time when an attempt is made to x-lock.
              
              Current code considers ::writer_thread as valid memory region only when
              the lock is held in x-mode (or there is an x-waiter). This is an
              overkill and it generates valgrind warnings.
              
              The fix is to consider ::writer_thread as valid memory region once it
              has been written to.
              
              Reasoning:
              ==========
              The ::writer_thread can be safely considered valid because:
              
              * We only ever do comparison with current calling threads id.
              * We only ever do comparison when ::recursive flag is set
              * We always unset ::recursive flag in x-unlock
              * Same thread cannot be unlocking and attempting to lock at the same
              time
              * thread_id recycling is not an issue because before an id is recycled
              the thread must leave innodb meaning it must release all locks meaning
              it must unset ::recursive flag.
            ------------------------------------------------------------
            revno: 2555.937.127
            committer: Luis Soares <luis.soares@oracle.com>
            branch nick: mysql-5.1
            timestamp: Mon 2012-03-12 23:23:40 +0000
            message:
              BUG#12400313
              
              Adding missing sync_slave_with_master to the test case.
            ------------------------------------------------------------
            revno: 2555.937.126 [merge]
            committer: Luis Soares <luis.soares@oracle.com>
            branch nick: mysql-5.1
            timestamp: Mon 2012-03-12 23:16:44 +0000
            message:
              Automerge merge with latest mysql-5.1.
                ------------------------------------------------------------
                revno: 2555.959.2
                committer: Luis Soares <luis.soares@oracle.com>
                branch nick: mysql-5.1
                timestamp: Mon 2012-03-12 23:15:01 +0000
                message:
                  BUG#12400313
                  
                  Hardening the test case:
                    - including a diff_tables at the end.
                    - increasing the tolerance on the relay limit size.
            ------------------------------------------------------------
            revno: 2555.937.125 [merge]
            committer: Luis Soares <luis.soares@oracle.com>
            branch nick: mysql-5.1
            timestamp: Mon 2012-03-12 21:58:00 +0000
            message:
              BUG#12400313
              
              Automerge with mysql-5.1.
                ------------------------------------------------------------
                revno: 2555.959.1
                committer: Luis Soares <luis.soares@oracle.com>
                branch nick: mysql-5.1
                timestamp: Mon 2012-03-12 12:28:27 +0000
                message:
                  BUG#12400313 RELAY_LOG_SPACE_LIMIT IS NOT WORKING IN MANY CASES
                  BUG#64503: mysql frequently ignores --relay-log-space-limit
                  
                  When the SQL thread goes to sleep, waiting for more events, it sets
                  the flag ignore_log_space_limit to true. This gives the IO thread a
                  chance to queue some more events and ultimately the SQL thread will be
                  able to purge the log once it is rotated. By then the SQL thread
                  resets the ignore_log_space_limit to false. However, between the time
                  the SQL thread has set the ignore flag and the time it resets it, the
                  IO thread will be queuing events in the relay log, possibly going way
                  over the limit.
                  
                  This patch makes the IO and SQL thread to synchronize when they reach
                  the space limit and only ask for one event at a time. Thus the SQL
                  thread sets ignore_log_space_limit flag and the IO thread resets it to
                  false everytime it processes one more event. In addition, everytime
                  the SQL thread processes the next event, and the limit has been
                  reached, it checks if the IO thread should rotate. If it should, it
                  instructs the IO thread to rotate, giving the SQL thread a chance to
                  purge the logs (freeing space). Finally, this patch removes the
                  resetting of the ignore_log_space_limit flag from purge_first_log,
                  because this is now reset by the IO thread every time it processes the
                  next event when the limit has been reached.
                  
                  If the SQL thread is in a transaction, it cannot purge so, there is no
                  point in asking the IO thread to rotate. The only thing it can do is
                  to ask for more events until the transaction is over (then it can ask
                  the IO to rotate and purge the log right away). Otherwise, there would
                  be a deadlock (SQL would not be able to purge and IO thread would not
                  be able to queue events so that the SQL would finish the transaction).
            ------------------------------------------------------------
            revno: 2555.937.124
            committer: Annamalai Gurusami <annamalai.gurusami@oracle.com>
            branch nick: mysql-5.1-bug11766634
            timestamp: Fri 2012-03-09 11:07:16 +0530
            message:
              Bug #11766634 59783: InnoDB data grows unexpectedly when inserting,
              truncating, inserting the same set of rows. When a table is 
              re-created with the same set of rows, the data file size must
              not grow.  
              
              rb:968
              Approved by Marko. 
            ------------------------------------------------------------
            revno: 2555.937.123
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-03-08 17:10:10 +0200
            message:
              Fix a compiler warning about possibly uninitiaizlied variable.
        ------------------------------------------------------------
        revno: 2555.949.32
        committer: Norvald H. Ryeng <norvald.ryeng@oracle.com>
        branch nick: mysql-5.1-security-13031606
        timestamp: Mon 2012-03-12 08:56:56 +0100
        message:
          Bug#13031606 VALUES() IN A SELECT STATEMENT CRASHES SERVER
          
          Problem: Grouping results by VALUES(alias for string literal) causes
          the server to crash.
          
          Item_insert_values is not constructed to handle other types of
          arguments than field and reference to field. In this case, the
          argument is an Item_string, and this causes
          Item_insert_values::fix_fields() to crash.
          
          Fix: Issue an error message when the argument to Item_insert_values is
          not a field or a reference to a field.
          
          This is slightly in breach with documentation, which states that
          VALUES should return NULL, but the error message is only issued in
          cases where the server otherwise would crash, so there is no change in
          behavior for queries that already work. Future versions will restrict
          syntax so that using VALUES in this way is illegal.
        ------------------------------------------------------------
        revno: 2555.949.31
        committer: Dmitry Lenev <Dmitry.Lenev@oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Sun 2012-03-11 16:05:42 +0400
        message:
          Fixed test case for bug #13105873 "valgrind warning:possible
          crash in foreign key handling on subsequent create table if
          not exists".
          
          Do not leave current database unassigned after the end of
          the test case.
        ------------------------------------------------------------
        revno: 2555.949.30 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Thu 2012-03-08 17:20:03 +0200
        message:
          empty weave merge mysql-5.0-security->mysql-5.1-security
            ------------------------------------------------------------
            revno: 1810.4002.36 [merge]
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: merge-5.0-security
            timestamp: Thu 2012-03-08 17:15:43 +0200
            message:
              empty auto merge of mysql-5.0->mysql-5.0-security
        ------------------------------------------------------------
        revno: 2555.949.29 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Thu 2012-03-08 17:16:53 +0200
        message:
          merge mysql-5.1->mysql-5.1-security
            ------------------------------------------------------------
            revno: 2555.937.122
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-03-08 14:56:22 +0200
            message:
              Bug#13807811 BTR_PCUR_RESTORE_POSITION() CAN SKIP A RECORD
              
              This bug has been there at least since MySQL 4.0.9. (Before 4.0.9, the
              code probably was even more severely broken.)
              
              btr_pcur_restore_position(): When cursor restoration fails, before
              invoking btr_pcur_store_position() move to the previous or next record
              unless cursor->rel_pos==BTR_PCUR_ON or the record was not a user
              record.
              
              This bug can cause skipped records when btr_pcur_store_position() is
              called on the last record of a page. A symptom would be record count
              mismatch in CHECK TABLE, or failure to find a record to delete-mark or
              update or purge. The following operations should be affected by the
              bug:
              
              * row_search_for_mysql(): SELECT, UPDATE, REPLACE, CHECK TABLE,
                (almost anything else than INSERT)
              
              * foreign key CASCADE operations
              
              * row_merge_read_clustered_index(): index creation (since MySQL 5.1
                InnoDB Plugin)
              
              * multi-threaded purge (after MySQL 5.5): not sure, but it might fail
                to purge some records
              
              Not all callers of btr_pcur_restore_position() should be affected.
              Anything that asserts or checks that restoration succeeds is
              unaffected. For example, cursor restoration on the change buffer tree
              should always succeed, because access is being protected by additional
              latches. Likewise, rollback, or any code accesses data dictionary
              tables while holding dict_sys->mutex should be safe.
              
              rb:967 approved by Jimmy Yang
            ------------------------------------------------------------
            revno: 2555.937.121
            committer: Tor Didriksen <tor.didriksen@oracle.com>
            branch nick: 5.1
            timestamp: Tue 2012-03-06 13:30:30 +0100
            message:
              Bug#11761576 54082: HANDLE_SEGFAULT MAKES USE OF UNSAFE FUNCTIONS
              
              Post-push fixes.
            ------------------------------------------------------------
            revno: 2555.937.120 [merge]
            committer: Mattias Jonsson <mattias.jonsson@oracle.com>
            branch nick: topush-5.1
            timestamp: Wed 2012-02-29 20:51:38 +0100
            message:
              merge into mysql-5.1
                ------------------------------------------------------------
                revno: 2555.958.1
                committer: Mattias Jonsson <mattias.jonsson@oracle.com>
                branch nick: b11761296-5.1_no_qc
                timestamp: Mon 2012-02-20 22:59:11 +0100
                message:
                  Bug#11761296: 53775: QUERY ON PARTITIONED TABLE RETURNS CACHED
                                                          RESULT FROM PREVIOUS TRANSACTION
                  
                  The current Query Cache API is not fully compatible with
                  the partitioning engine.
                  
                  There is no good way to implement support for QC due to:
                  1) a static callback for ha_partition would need to have access
                  to all partition names and call the underlying callback for each
                  [sub]partition with the correct name.
                  2) pruning would be impossible, even if one used the ulonglong
                  engine_data due to if engine_data is changed, the table is
                  invalidated by the QC.
                  
                  So the only viable solution to avoid incorrect data is to not allow
                  caching of queries using partitioned tables.
                  
                  (There are some extra changes, due to removal of \r as line break)
            ------------------------------------------------------------
            revno: 2555.937.119 [merge]
            committer: Praveenkumar Hulakund <praveenkumar.hulakund@oracle.com>
            branch nick: mysql-5.1-new
            timestamp: Wed 2012-02-29 14:52:08 +0530
            message:
              Bug#12601974 - STORED PROCEDURE SQL_MODE=NO_BACKSLASH_ESCAPES IGNORED AND BREAKS REPLICATION
              
              Analysis:
              ========================
              sql_mode "NO_BACKSLASH_ESCAPES": When user want to use backslash as character input,
              instead of escape character in a string literal then sql_mode can be set to 
              "NO_BACKSLASH_ESCAPES". With this mode enabled, backslash becomes an ordinary 
              character like any other. 
              
              SQL_MODE set applies to the current client session. And while creating the stored 
              procedure, MySQL stores the current sql_mode and always executes the stored 
              procedure in sql_mode stored with the Procedure, regardless of the server SQL 
              mode in effect when the routine is invoked.  
              
              In the scenario (for which bug is reported), the routine is created with 
              sql_mode=NO_BACKSLASH_ESCAPES. And routine is executed with the invoker sql_mode
              is "" (NOT SET) by executing statement "call testp('Axel\'s')".
              Since invoker sql_mode is "" (NOT_SET), the '\' in 'Axel\'s'(argument to function)
              is considered as escape character and column "a" (of table "t1") values are 
              updated with "Axel's". The binary log generated for above update operation is as below,
              
                set sql_mode=XXXXXX (for no_backslash_escapes)
                update test.t1 set a= NAME_CONST('var',_latin1'Axel\'s' COLLATE 'latin1_swedish_ci');
              
              While logging stored procedure statements, the local variables (params) used in
              statements are replaced with the NAME_CONST(var_name, var_value) (Internal function) 
              (http://dev.mysql.com/doc/refman/5.6/en/miscellaneous-functions.html#function_name-const)
              
              On slave, these logs are applied. NAME_CONST is parsed to get the variable and its
              value. Since, stored procedure is created with sql_mode="NO_BACKSLASH_ESCAPES", the sql_mode
              is also logged in. So that at slave this sql_mode is set before executing the statements
              of routine.  So at slave, sql_mode is set to "NO_BACKSLASH_ESCAPES" and then while
              parsing NAME_CONST of string variable, '\' is considered as NON ESCAPE character
              and parsing reported error for "'" (as we have only one "'" no backslash). 
              
              At slave, parsing was proper with sql_mode "NO_BACKSLASH_ESCAPES".
              But above error reported while writing bin log, "'" (of Axel's) is escaped with
              "\" character. Actually, all special characters (n, r, ', ", \, 0...) are escaped
              while writing NAME_CONST for string variable(param, local variable) in bin log 
              irrespective of "NO_BACKSLASH_ESCAPES" sql_mode. So, basically, the problem is 
              that logging string parameter does not take into account sql_mode value.
              
              Fix:
              ========================
              So when sql_mode is set to "NO_BACKSLASH_ESCAPES", escaping  characters as 
              (n, r, ', ", \, 0...) should be avoided. To do so, added a check to not to
              escape such characters while writing NAME_CONST for string variables in bin 
              log. 
              And when sql_mode is set to NO_BACKSLASH_ESCAPES, quote character "'" is
              represented as ''.
              http://dev.mysql.com/doc/refman/5.6/en/string-literals.html (There are several 
              ways to include quote characters within a string: )
                ------------------------------------------------------------
                revno: 2555.957.1
                committer: Praveenkumar Hulakund <praveenkumar.hulakund@oracle.com>
                branch nick: mysql-5.1
                timestamp: Wed 2012-02-29 12:23:15 +0530
                message:
                  Bug#12601974 - STORED PROCEDURE SQL_MODE=NO_BACKSLASH_ESCAPES IGNORED AND BREAKS REPLICATION
                  
                  Analysis:
                  ========================
                  sql_mode "NO_BACKSLASH_ESCAPES": When user want to use backslash as character input,
                  instead of escape character in a string literal then sql_mode can be set to 
                  "NO_BACKSLASH_ESCAPES". With this mode enabled, backslash becomes an ordinary 
                  character like any other. 
                  
                  SQL_MODE set applies to the current client session. And while creating the stored 
                  procedure, MySQL stores the current sql_mode and always executes the stored 
                  procedure in sql_mode stored with the Procedure, regardless of the server SQL 
                  mode in effect when the routine is invoked.  
                  
                  In the scenario (for which bug is reported), the routine is created with 
                  sql_mode=NO_BACKSLASH_ESCAPES. And routine is executed with the invoker sql_mode
                  is "" (NOT SET) by executing statement "call testp('Axel\'s')".
                  Since invoker sql_mode is "" (NOT_SET), the '\' in 'Axel\'s'(argument to function)
                  is considered as escape character and column "a" (of table "t1") values are 
                  updated with "Axel's". The binary log generated for above update operation is as below,
                  
                    set sql_mode=XXXXXX (for no_backslash_escapes)
                    update test.t1 set a= NAME_CONST('var',_latin1'Axel\'s' COLLATE 'latin1_swedish_ci');
                  
                  While logging stored procedure statements, the local variables (params) used in
                  statements are replaced with the NAME_CONST(var_name, var_value) (Internal function) 
                  (http://dev.mysql.com/doc/refman/5.6/en/miscellaneous-functions.html#function_name-const)
                  
                  On slave, these logs are applied. NAME_CONST is parsed to get the variable and its
                  value. Since, stored procedure is created with sql_mode="NO_BACKSLASH_ESCAPES", the sql_mode
                  is also logged in. So that at slave this sql_mode is set before executing the statements
                  of routine.  So at slave, sql_mode is set to "NO_BACKSLASH_ESCAPES" and then while
                  parsing NAME_CONST of string variable, '\' is considered as NON ESCAPE character
                  and parsing reported error for "'" (as we have only one "'" no backslash). 
                  
                  At slave, parsing was proper with sql_mode "NO_BACKSLASH_ESCAPES".
                  But above error reported while writing bin log, "'" (of Axel's) is escaped with
                  "\" character. Actually, all special characters (n, r, ', ", \, 0...) are escaped
                  while writing NAME_CONST for string variable(param, local variable) in bin log 
                  Airrespective of "NO_BACKSLASH_ESCAPES" sql_mode. So, basically, the problem is 
                  that logging string parameter does not take into account sql_mode value.
                  
                  Fix:
                  ========================
                  So when sql_mode is set to "NO_BACKSLASH_ESCAPES", escaping  characters as 
                  (n, r, ', ", \, 0...) should be avoided. To do so, added a check to not to
                  escape such characters while writing NAME_CONST for string variables in bin 
                  log. 
                  And when sql_mode is set to NO_BACKSLASH_ESCAPES, quote character "'" is
                  represented as ''.
                  http://dev.mysql.com/doc/refman/5.6/en/string-literals.html (There are several 
                  ways to include quote characters within a string: )
            ------------------------------------------------------------
            revno: 2555.937.118
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Tue 2012-02-28 21:41:55 +0200
            message:
              Fix a mistake in the Bug#12861864 fix.
              
              row_drop_table_for_mysql(): Really flag the indexes unavailable before
              starting to drop the table.
            ------------------------------------------------------------
            revno: 2555.937.117
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Tue 2012-02-28 14:00:00 +0200
            message:
              Bug#12861864 RACE CONDITION IN BTR_GET_SIZE() AND DROP INDEX/TABLE/DATABASE
              also filed as Bug#13146269, Bug#13713178
              
              btr_get_size(): Add mtr_t parameter. Require that the caller S-latches
              index->lock. If index->page==FIL_NULL or the index is to be dropped,
              return ULINT_UNDEFINED to indicate that the statistics are
              unavailable.
              
              dict_update_statistics(): If btr_get_size() returns ULINT_UNDEFINED,
              fake the index cardinality statistics.
              
              dict_index_set_page(): Unused function, remove.
              
              row_drop_table_for_mysql(): Before starting to drop the table, mark
              the indexes unavailable in the data dictionary cache while holding
              index->lock X-latch.
              
              ha_innobase::prepare_drop_index(), ha_innobase::final_drop_index():
              When setting index->to_be_dropped, acquire the index->lock X-latch.
              
              rb:960 approved by Jimmy Yang
            ------------------------------------------------------------
            revno: 2555.937.116
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Mon 2012-02-27 23:19:14 +0200
            message:
              Remove a bogus BLOB debug assertion that was added in Bug#13721257 fix.
            ------------------------------------------------------------
            revno: 2555.937.115
            committer: Chaithra Gopalareddy <chaithra.gopalareddy@oracle.com>
            branch nick: mysql-5.1
            timestamp: Fri 2012-02-24 11:53:36 +0530
            message:
              Bug#13012483:EXPLAIN EXTENDED, PREPARED STATEMENT, CRASH IN
              CHECK_SIMPLE_EQUALITY
              
              PROBLEM:
              Crash in "check_simple_equality" when using a subquery with "IN" and
              "ALL" in prepare.
              
              ANALYSIS:
              Crash can be reproduced using a simplified query like this one:
              prepare s from "select 1 from g1 where 1 < all (
                              select @:=(1 in (select 1 from g1)) from g1)";
              
              This bug is currently present only on 5.5.and 5.1. Its fixed as part
              of work log(#1110) in 5.6. We are taking one change to fix this
              in 5.5 and 5.1.
              
              Problem seems to be present because we are trying to evaluate "is_null"
              on an argument which is part of a subquery
              (In Item_is_not_null_test::update_used_tables()).
              But the condition to evaluate is only when we do not have a sub query
              present, which means to say that "with_subselect" is not set.
              With respect to the above query, we create an object of type
              "Item_in_optimizer" which by definition is always associated with a
              subquery. While in 5.6 we set "with_subselect" to true for
              "Item_in_optimizer" object, we do not do the same in 5.5. This results in
              the evaluation for "is_null" resulting in a coredump.
              So, we are now setting "with_subselect" to true for "Item_in_optimizer"
              in 5.1 and 5.5.
            ------------------------------------------------------------
            revno: 2555.937.114
            committer: Vasil Dimov <vasil.dimov@oracle.com>
            branch nick: mysql-5.1
            timestamp: Tue 2012-02-21 17:57:07 +0200
            message:
              Fix Bug#13639142 64128: INNODB ERROR IN SERVER LOG OF INNODB_BUG34300
              
              Suppress innodb_bug34300 from failing if InnoDB prints:
              
                120221 11:05:03  InnoDB: ERROR: the age of the last checkpoint is 9439048,
                InnoDB: which exceeds the log group capacity 9433498.
              
              by default the log capacity is 2 log files, 5 MB each.
            ------------------------------------------------------------
            revno: 2555.937.113 [merge]
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: mysql-5.1
            timestamp: Tue 2012-02-21 14:14:52 +0200
            message:
              merged and updated the version in mysql-5.1
                ------------------------------------------------------------
                revno: 1810.3999.20
                committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
                branch nick: mysql-5.0
                timestamp: Tue 2012-02-21 14:13:31 +0200
                message:
                  bumped up the version of the main tree to match the security tree
            ------------------------------------------------------------
            revno: 2555.937.112
            committer: Tatjana Azundris Nuernberg <tatjana.nuernberg@oracle.com>
            branch nick: 51-13454045
            timestamp: Sun 2012-02-19 03:18:49 +0000
            message:
              BUG 13454045 - 63524: BUG #35396 "ABNORMAL/IMPOSSIBLE/LARGE QUERY_TIME AND LOCK_TIME" HAPPENS A
              
              If a query's end time is before before its start time, the system clock has been turn back
              (daylight savings time etc.). When the system clock is changed, we can't tell for certain a
              given query was actually slow. We did not protect against logging such a query with a bogus
              execution time (resulting from end_time - start_time being negative), and possibly logging it
              even though it did not really take long to run.
              
              We now have a sanity check in place.
        ------------------------------------------------------------
        revno: 2555.949.28
        committer: Ramil Kalimullin <ramil.kalimullin@oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Tue 2012-03-06 15:13:56 +0400
        message:
          BUG#12537203 - CRASH WHEN SUBSELECTING GLOBAL VARIABLES IN 
          GEOMETRY FUNCTION ARGUMENTS
          
          Fixed --ps-protocol gis test failure.
        ------------------------------------------------------------
        revno: 2555.949.27
        committer: Ramil Kalimullin <ramil.kalimullin@oracle.com>
        branch nick: b12537203-5.1-security
        timestamp: Mon 2012-03-05 22:15:23 +0400
        message:
          BUG#12537203 - CRASH WHEN SUBSELECTING GLOBAL VARIABLES IN GEOMETRY FUNCTION ARGUMENTS
          
          A defect in the subquery substitution code may lead to a server crash:
          setting substitution's name should be followed by setting its length
          (to keep them in sync).
        ------------------------------------------------------------
        revno: 2555.949.26
        committer: Ramil Kalimullin <ramil.kalimullin@oracle.com>
        branch nick: b12414917-5.1-security
        timestamp: Mon 2012-03-05 21:58:07 +0400
        message:
          Fix for BUG#12414917 - ISCLOSED() CRASHES ON 64-BIT BUILDS 
          
          Problem:      
          lack of incoming geometry data validation may 
          lead to a server crash when ISCLOSED() function called.
          
          Solution:
          necessary incoming data check added.
        ------------------------------------------------------------
        revno: 2555.949.25
        committer: Annamalai Gurusami <annamalai.gurusami@oracle.com>
        branch nick: mysql-5.1-security-bug13635833
        timestamp: Thu 2012-03-01 15:44:23 +0530
        message:
          The innodb plugin module cannot use DEBUG_SYNC_C facility on Windows. 
          Taking care of it.  
        ------------------------------------------------------------
        revno: 2555.949.24
        committer: Annamalai Gurusami <annamalai.gurusami@oracle.com>
        branch nick: mysql-5.1-security-bug13635833
        timestamp: Thu 2012-03-01 11:05:51 +0530
        message:
          Bug#13635833: MULTIPLE CRASHES IN FOREIGN KEY CODE WITH CONCURRENT DDL/DML
                
          There are two threads.  In one thread, dml operation is going on 
          involving cascaded update operation.  In another thread, alter 
          table add foreign key constraint is happening.  Under these 
          circumstances, it is possible for the dml thread to access a 
          dict_foreign_t object that has been freed by the ddl thread.  
          The debug sync test case provides the sequence of operations.  
          Without fix, the test case will crash the server (because of 
          newly added assert).  With fix, the alter table stmt will return 
          an error message.  
                
          Backporting the fix from MySQL 5.5 to 5.1
          
          rb:961
          rb:947
        ------------------------------------------------------------
        revno: 2555.949.23 [merge]
        committer: Tatjana Azundris Nuernberg <tatjana.nuernberg@oracle.com>
        branch nick: 51-13431369pb
        timestamp: Wed 2012-02-22 16:18:12 +0100
        message:
          auto-merge
            ------------------------------------------------------------
            revno: 2555.956.1 [merge]
            committer: Tatjana Azundris Nuernberg <tatjana.nuernberg@oracle.com>
            branch nick: 51-13431369
            timestamp: Sun 2012-02-19 08:57:11 +0000
            message:
              BUG#13431369 - MAIN.VARIABLES-NOTEMBEDDED CRASHES THE SERVER SPORADICALLY ON WINDOWS
              
              On shutdown(), Windows can drop traffic still queued for sending even if that
              wasn't specifically requested. As a result, fatal errors (those after
              signaling which the server will drop the connection) were sometimes only
              seen as "connection lost" on the client side, because the server-side
              shutdown() erraneously discarded the correct error message before sending
              it.
              
              If on Windows, we now use the Windows API to access the (non-broken) equivalent
              of shutdown().
              
              Backport from trunk
                ------------------------------------------------------------
                revno: 2555.955.1
                committer: Tatjana Azundris Nuernberg <tatjana.nuernberg@oracle.com>
                branch nick: mysql-5.1-security
                timestamp: Fri 2012-02-17 19:02:17 +0000
                message:
                  BUG#13431369 - MAIN.VARIABLES-NOTEMBEDDED CRASHES THE SERVER SPORADICALLY ON WINDOWS
                  
                  On shutdown(), Windows can drop traffic still queued for sending even if that
                  wasn't specifically requested. As a result, fatal errors (those after
                  signaling which the server will drop the connection) were sometimes only
                  seen as "connection lost" on the client side, because the server-side
                  shutdown() erraneously discarded the correct error message before sending
                  it.
                  
                  If on Windows, we now use the Windows API to access the (non-broken) equivalent
                  of shutdown().
                  
                  Backport from trunk
        ------------------------------------------------------------
        revno: 2555.949.22
        committer: Tor Didriksen <tor.didriksen@oracle.com>
        branch nick: 5.1-security
        timestamp: Wed 2012-02-22 11:17:50 +0100
        message:
          Bug#13519724 63793: CRASH IN DTCOLLATION::SET(DTCOLLATION &SET)
          
          Backport of fix for:
          Bug#53236 Segfault in DTCollation::set(DTCollation&)
        ------------------------------------------------------------
        revno: 2555.949.21 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Tue 2012-02-21 11:06:08 +0200
        message:
          merge 5.0-security->5.1-security
            ------------------------------------------------------------
            revno: 1810.4002.35
            committer: Sunanda Menon <sunanda.menon@oracle.com>
            branch nick: mysql-5.0-security
            timestamp: Mon 2012-02-20 06:19:12 +0100
            message:
              Raise version number after cloning 5.0.96
        ------------------------------------------------------------
        revno: 2555.949.20
        committer: Karen Langford <karen.langford@oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Mon 2012-02-20 17:03:24 +0100
        message:
          Raise version number after cloning 5.1.62
        ------------------------------------------------------------
        revno: 2555.949.19 [merge]
        tags: clone-5.1.62-build
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Sat 2012-02-18 10:58:19 +0200
        message:
          merge mysql-5.1->mysql-5.1-security
            ------------------------------------------------------------
            revno: 2555.937.111
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Fri 2012-02-17 11:42:04 +0200
            message:
              Bug#13721257 RACE CONDITION IN UPDATES OR INSERTS OF WIDE RECORDS
              
              This bug was originally filed and fixed as Bug#12612184. The original
              fix was buggy, and it was patched by Bug#12704861. Also that patch was
              buggy (potentially breaking crash recovery), and both fixes were
              reverted.
              
              This fix was not ported to the built-in InnoDB of MySQL 5.1, because
              the function signatures of many core functions are different from
              InnoDB Plugin and later versions. The block allocation routines and
              their callers would have to changed so that they handle block
              descriptors instead of page frames.
              
              When a record is updated so that its size grows, non-updated columns
              can be selected for external (off-page) storage. The bug is that the
              initially inserted updated record contains an all-zero BLOB pointer to
              the field that was not updated. Only after the BLOB pages have been
              allocated and written, the valid pointer can be written to the record.
              
              Between the release of the page latch in mtr_commit(mtr) after
              btr_cur_pessimistic_update() and the re-latching of the page in
              btr_pcur_restore_position(), other threads can see the invalid BLOB
              pointer consisting of 20 zero bytes. Moreover, if the system crashes
              at this point, the situation could persist after crash recovery, and
              the contents of the non-updated column would be permanently lost.
              
              The problem is amplified by the ROW_FORMAT=DYNAMIC and
              ROW_FORMAT=COMPRESSED that were introduced in
              innodb_file_format=barracuda in InnoDB Plugin, but the bug does exist
              in all InnoDB versions.
              
              The fix is as follows. After a pessimistic B-tree operation that needs
              to write out off-page columns, allocate the pages for these columns in
              the mini-transaction that performed the B-tree operation (btr_mtr),
              but write the pages in a separate mini-transaction (blob_mtr). Do
              mtr_commit(blob_mtr) before mtr_commit(btr_mtr). A quirk: Do not reuse
              pages that were previously freed in btr_mtr. Only write the off-page
              columns to 'fresh' pages.
              
              In this way, crash recovery will see redo log entries for blob_mtr
              before any redo log entry for btr_mtr. It will apply the BLOB page
              writes to pages that were marked free at that point. If crash recovery
              fails to see all of the btr_mtr redo log, there will be some
              unreachable BLOB data in free pages, but the B-tree will be in a
              consistent state.
              
              btr_page_alloc_low(): Renamed from btr_page_alloc(). Add the parameter
              init_mtr. Return an allocated block, or NULL. If init_mtr!=mtr but
              the page was already X-latched in mtr, do not initialize the page.
              
              btr_page_alloc(): Wrapper for btr_page_alloc_for_ibuf() and
              btr_page_alloc_low().
              
              btr_page_free(): Add a debug assertion that the page was a B-tree page.
              
              btr_lift_page_up(): Return the father block.
              
              btr_compress(), btr_cur_compress_if_useful(): Add the parameter ibool
              adjust, for adjusting the cursor position.
              
              btr_cur_pessimistic_update(): Preserve the cursor position when
              big_rec will be written and the new flag BTR_KEEP_POS_FLAG is defined.
              Remove a duplicate rec_get_offsets() call. Keep the X-latch on
              index->lock when big_rec is needed.
              
              btr_store_big_rec_extern_fields(): Replace update_inplace with
              an operation code, and local_mtr with btr_mtr. When not doing a
              fresh insert and btr_mtr has freed pages, put aside any pages that
              were previously X-latched in btr_mtr, and free the pages after
              writing out all data. The data must be written to 'fresh' pages,
              because btr_mtr will be committed and written to the redo log after
              the BLOB writes have been written to the redo log.
              
              btr_blob_op_is_update(): Check if an operation passed to
              btr_store_big_rec_extern_fields() is an update or insert-by-update.
              
              fseg_alloc_free_page_low(), fsp_alloc_free_page(),
              fseg_alloc_free_extent(), fseg_alloc_free_page_general(): Add the
              parameter init_mtr. Return an allocated block, or NULL. If
              init_mtr!=mtr but the page was already X-latched in mtr, do not
              initialize the page.
              
              xdes_get_descriptor_with_space_hdr(): Assert that the file space
              header is being X-latched.
              
              fsp_alloc_from_free_frag(): Refactored from fsp_alloc_free_page().
              
              fsp_page_create(): New function, for allocating, X-latching and
              potentially initializing a page. If init_mtr!=mtr but the page was
              already X-latched in mtr, do not initialize the page.
              
              fsp_free_page(): Add ut_ad(0) to the error outcomes.
              
              fsp_free_page(), fseg_free_page_low(): Increment mtr->n_freed_pages.
              
              fsp_alloc_seg_inode_page(), fseg_create_general(): Assert that the
              page was not previously X-latched in the mini-transaction. A file
              segment or inode page should never be allocated in the middle of an
              mini-transaction that frees pages, such as btr_cur_pessimistic_delete().
              
              fseg_alloc_free_page_low(): If the hinted page was allocated, skip the
              check if the tablespace should be extended. Return NULL instead of
              FIL_NULL on failure. Remove the flag frag_page_allocated. Instead,
              return directly, because the page would already have been initialized.
              
              fseg_find_free_frag_page_slot() would return ULINT_UNDEFINED on error,
              not FIL_NULL. Correct a bogus assertion.
              
              fseg_alloc_free_page(): Redefine as a wrapper macro around
              fseg_alloc_free_page_general().
              
              buf_block_buf_fix_inc(): Move the definition from the buf0buf.ic to
              buf0buf.h, so that it can be called from other modules.
              
              mtr_t: Add n_freed_pages (number of pages that have been freed).
              
              page_rec_get_nth_const(), page_rec_get_nth(): The inverse function of
              page_rec_get_n_recs_before(), get the nth record of the record
              list. This is faster than iterating the linked list. Refactored from
              page_get_middle_rec().
              
              trx_undo_rec_copy(): Add a debug assertion for the length.
              
              trx_undo_add_page(): Return a block descriptor or NULL instead of a
              page number or FIL_NULL.
              
              trx_undo_report_row_operation(): Add debug assertions.
              
              trx_sys_create_doublewrite_buf(): Assert that each page was not
              previously X-latched.
              
              page_cur_insert_rec_zip_reorg(): Make use of page_rec_get_nth().
              
              row_ins_clust_index_entry_by_modify(): Pass BTR_KEEP_POS_FLAG, so that
              the repositioning of the cursor can be avoided.
              
              row_ins_index_entry_low(): Add DEBUG_SYNC points before and after
              writing off-page columns. If inserting by updating a delete-marked
              record, do not reposition the cursor or commit the mini-transaction
              before writing the off-page columns.
              
              row_build(): Tighten a debug assertion about null BLOB pointers.
              
              row_upd_clust_rec(): Add DEBUG_SYNC points before and after writing
              off-page columns. Do not reposition the cursor or commit the
              mini-transaction before writing the off-page columns.
              
              rb:939 approved by Jimmy Yang
        ------------------------------------------------------------
        revno: 2555.949.18 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Fri 2012-02-17 11:55:06 +0200
        message:
          merge mysql-5.0-security->mysql-5.1-security
            ------------------------------------------------------------
            revno: 1810.4002.34 [merge]
            tags: clone-5.0.96-build
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: merge-5.0-security
            timestamp: Fri 2012-02-17 11:51:14 +0200
            message:
              merged mysql-5.0->mysql-5.0-security
        ------------------------------------------------------------
        revno: 2555.949.17 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Fri 2012-02-17 11:52:41 +0200
        message:
          merge mysql-5.1->mysql-5.1-security
            ------------------------------------------------------------
            revno: 2555.937.110
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-02-16 15:54:16 +0200
            message:
              Fix link error on Windows.
              error LNK2001: unresolved external symbol _debug_sync_C_callback_ptr
            ------------------------------------------------------------
            revno: 2555.937.109 [merge]
            committer: Kent Boortz <kent.boortz@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-02-16 12:02:53 +0100
            message:
              Merge
                ------------------------------------------------------------
                revno: 2555.954.4
                committer: Marko M?kel? <marko.makela@oracle.com>
                branch nick: mysql-5.1
                timestamp: Thu 2012-02-16 12:24:11 +0200
                message:
                  Add instrumentation for Bug#13721257 RACE CONDITION IN UPDATES OR INSERTS
                  OF WIDE RECORDS
                  
                  row_ins_index_entry_low(), row_upd_clust_rec(): Make a redo log
                  checkpoint if a DEBUG flag is set. Add DEBUG_SYNC around
                  btr_store_big_rec_extern_fields().
                  
                  rb:946 approved by Jimmy Yang
                ------------------------------------------------------------
                revno: 2555.954.3
                committer: Marko M?kel? <marko.makela@oracle.com>
                branch nick: mysql-5.1
                timestamp: Thu 2012-02-16 12:20:41 +0200
                message:
                  Correct a few copyright messages.
            ------------------------------------------------------------
            revno: 2555.937.108
            committer: MySQL Build Team<mysql-build@oss.oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-02-16 11:35:30 +0100
            message:
              Updated/added copyright headers
            ------------------------------------------------------------
            revno: 2555.937.107 [merge]
            committer: Kent Boortz <kent.boortz@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-02-16 11:17:04 +0100
            message:
              Merge
                ------------------------------------------------------------
                revno: 2555.954.2
                committer: Marko M?kel? <marko.makela@oracle.com>
                branch nick: mysql-5.1
                timestamp: Wed 2012-02-15 16:28:00 +0200
                message:
                  Remove a race condition in innodb_bug53756.test.
                  Before killing the server, tell mysql-test-run that it is to be expected.
                  
                  Discussed with Bjorn Munch on IM.
                ------------------------------------------------------------
                revno: 2555.954.1
                committer: Marko M?kel? <marko.makela@oracle.com>
                branch nick: mysql-5.1
                timestamp: Wed 2012-02-15 15:53:29 +0200
                message:
                  store_create_info(): Fix a compiler warning about unused variable.
            ------------------------------------------------------------
            revno: 2555.937.106 [merge]
            committer: Kent Boortz <kent.boortz@oracle.com>
            branch nick: mysql-5.1
            timestamp: Wed 2012-02-15 17:21:38 +0100
            message:
              Updated/added copyright headers
                ------------------------------------------------------------
                revno: 1810.3999.19
                committer: MySQL Build Team<mysql-build@oss.oracle.com>
                branch nick: mysql-5.0
                timestamp: Wed 2012-02-15 17:13:47 +0100
                message:
                  Updated/added copyright headers
            ------------------------------------------------------------
            revno: 2555.937.105
            committer: Sunny Bains <Sunny.Bains@Oracle.Com>
            branch nick: 5.1
            timestamp: Fri 2012-02-10 14:09:12 +1100
            message:
              BUG#12739098 - 62401: ASSERTION TRX->ERROR_STATE == DB_SUCCESS, QUE0QUE.C LINE 1264 ON TRUNCATE 
                          
              During FIC error handling the trx->error_state was not being set to DB_SUCCESS
              after failure, before attempting the next DDL SQL operation. This reset to
              DB_SUCCESS is somewhat of a requirement though not explicitly stated anywhere.
              The fix is to reset it to DB_SUCCESS in row0merge.cc if row_merge_rename_indexes
              or row_merge_drop_index functions fail, also reset to DB_SUCCESS at trx commit.
              				          
              rb://935 Approved by Jimmy Yang.
        ------------------------------------------------------------
        revno: 2555.949.16 [merge]
        committer: Joerg Bruehe <joerg.bruehe@oracle.com>
        branch nick: security-5.1
        timestamp: Thu 2012-02-16 15:55:53 +0100
        message:
          Merge compile fix for AIX into delivery tree.
            ------------------------------------------------------------
            revno: 2555.953.1
            committer: Joerg Bruehe <joerg.bruehe@oracle.com>
            branch nick: bzero-5.1
            timestamp: Thu 2012-01-19 17:05:47 +0100
            message:
              Compile fix needed for AIX,
              to work around the lack of a bzero() prototype.
        ------------------------------------------------------------
        revno: 2555.949.15 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: B13706828-5.1-security
        timestamp: Mon 2012-02-13 13:40:12 +0200
        message:
          merge from 5.0-security
            ------------------------------------------------------------
            revno: 1810.4002.33
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: B13706828-5.0-security
            timestamp: Fri 2012-02-10 16:33:27 +0200
            message:
              Bug #13706828: UPGRADE YASSL FROM 1.7.2 TO 2.1.4
              
              $SUBJ$
              1. Took a diff between the previous base version and the
              mysql sources.
              2. Added the new 2.1.4 base version.
              3. Reviewed and re-applied the diff from step #1.
        ------------------------------------------------------------
        revno: 2555.949.14 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: upgrade-yassl-5.1-security
        timestamp: Fri 2012-02-10 11:49:48 +0200
        message:
          merge
            ------------------------------------------------------------
            revno: 2555.952.1
            committer: Martin Hansson <martin.hansson@oracle.com>
            branch nick: mysql-5.1-security
            timestamp: Tue 2012-02-07 14:16:09 +0100
            message:
              Bug #11765810 58813: SERVER THREAD HANGS WHEN JOIN + WHERE + GROUP BY
              IS EXECUTED TWICE FROM P
              
              This bug is a duplicate of bug 12567331, which was pushed to the
              optimizer backporting tree on 2011-06-11. This is just a back-port of
              the fix. Both test cases are included as they differ somewhat.
        ------------------------------------------------------------
        revno: 2555.949.13 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: upgrade-yassl-5.1-security
        timestamp: Fri 2012-02-10 11:39:51 +0200
        message:
          empty merge of mysql-5.0-security->mysql-5.1-security
            ------------------------------------------------------------
            revno: 1810.4002.32
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: upgrade-yassl-5.0-security
            timestamp: Fri 2012-02-10 11:10:07 +0200
            message:
              Bug#13706621 :  UNIFY THE YASSL VERSIONS THAT WE USE BY BACKPORTING 5.1 
              AND 5.5 YASSL FIXES.
              
              Took the 5.5 yassl code and applied it to the 5.0 codebase, keeping the
              compilation files.
        ------------------------------------------------------------
        revno: 2555.949.12
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: upgrade-yassl-5.1-security
        timestamp: Fri 2012-02-10 11:35:36 +0200
        message:
          Bug#13706621 :  UNIFY THE YASSL VERSIONS THAT WE USE BY BACKPORTING 5.1 
          AND 5.5 YASSL FIXES.
          
          Took the 5.5 yassl directory and moved it to the 5.1 tree, while
          preserving the makefiles.
        ------------------------------------------------------------
        revno: 2555.949.11 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Mon 2012-02-06 18:26:48 +0200
        message:
          empty weave merge mysql-5.0-security->mysql-5.1-security
            ------------------------------------------------------------
            revno: 1810.4002.31 [merge]
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: merge-5.0-security
            timestamp: Mon 2012-02-06 18:23:41 +0200
            message:
              merged mysql-5.0->mysql-5.0-security
        ------------------------------------------------------------
        revno: 2555.949.10 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Mon 2012-02-06 18:24:51 +0200
        message:
          merged mysql-5.1->mysql-5.1-security
            ------------------------------------------------------------
            revno: 2555.937.104
            committer: Vasil Dimov <vasil.dimov@oracle.com>
            branch nick: mysql-5.1
            timestamp: Mon 2012-02-06 12:44:59 +0200
            message:
              Fix Bug#11754376 45976: INNODB LOST FILES FOR TEMPORARY TABLES ON
              GRACEFUL SHUTDOWN
              
              During startup mysql picks up .frm files from the tmpdir directory and
              tries to drop those tables in the storage engine.
              
              The problem is that when tmpdir ends in / then ha_innobase::delete_table()
              is passed a string like "/var/tmp//#sql123", then it wrongly normalizes it
              to "/#sql123" and calls row_drop_table_for_mysql() which of course fails
              to delete the table entry from the InnoDB dictionary cache.
              ha_innobase::delete_table() returns an error but nevertheless mysql wipes
              away the .frm file and the entry in the InnoDB dictionary cache remains
              orphaned with no easy way to remove it.
              
              The "no easy" way to remove it is to create a similar temporary table again,
              copy its .frm file to tmpdir under "#sql123.frm" and restart mysqld with
              tmpdir=/var/tmp (no trailing slash) - this way mysql will pick the .frm file
              after restart and will try to issue drop table for "/var/tmp/#sql123"
              (notice do double slash), ha_innobase::delete_table() will normalize it to
              "tmp/#sql123" and row_drop_table_for_mysql() will successfully remove the
              table entry from the dictionary cache.
              
              The solution is to fix normalize_table_name_low() to normalize things like
              "/var/tmp//table" correctly to "tmp/table".
              
              This patch also adds a test function which invokes
              normalize_table_name_low() with various inputs to make sure it works
              correctly and a mtr test that calls this test function.
              
              Reviewed by:	Marko (http://bur03.no.oracle.com/rb/r/929/)
            ------------------------------------------------------------
            revno: 2555.937.103
            committer: Ashish Agarwal<ashish.y.agarwal@oracle.com>
            branch nick: bug_93_5.1
            timestamp: Fri 2012-02-03 19:37:00 +0530
            message:
              BUG#11748748 - 37280: CHECK AND REPAIR TABLE REPORT TABLE
                                    CORRUPTED WHEN RUN CONCURRENTLY WITH
              
              ISSUE: Table corruption due to concurrent queries.
                     Different threads running check, repair query
                     along with insert. Locks not properly acquired
                     in repair query. Rows are inserted inbetween
                     repair query.
              
              SOLUTION: Mutex lock is acquired before the
                        repair call. Concurrent queries wont
                        effect the call to repair.
            ------------------------------------------------------------
            revno: 2555.937.102
            committer: Alexander Barkov <alexander.barkov@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-02-02 16:22:13 +0400
            message:
              Postfix for Bug#11752408.
              Recording correct test results.
              
              modified:
                mysql-test/suite/engines/funcs/r/db_alter_collate_ascii.result
                mysql-test/suite/engines/funcs/r/db_alter_collate_utf8.result
            ------------------------------------------------------------
            revno: 2555.937.101
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-02-02 13:38:32 +0200
            message:
              Bug#13654923 BOGUS DEBUG ASSERTION IN INDEX CREATION FOR ZERO-LENGTH RECORD
              
              row_merge_buf_write(): Relax the bogus assertion.
            ------------------------------------------------------------
            revno: 2555.937.100
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-02-02 12:07:06 +0200
            message:
              Suppress messages about long semaphore waits in innodb_bug34300.test.
            ------------------------------------------------------------
            revno: 2555.937.99 [merge]
            committer: Ashish Agarwal<ashish.y.agarwal@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-02-02 14:19:38 +0530
            message:
              BUG#11756869 - 48848: MYISAMCHK DOING SORT RECOVER IN CERTAIN
                                    CASES RESETS DATA POINTER TO SMAL
              
              ISSUE: Myisamchk doing sort recover
                     on a table reduces data_file_length.
                     Maximum size of data file decreases,
                     lesser number of rows are stored.
              
              SOLUTION: Size of data_file_length is
                        fixed to the original length.
                ------------------------------------------------------------
                revno: 2555.951.1
                committer: Ashish Agarwal<ashish.y.agarwal@oracle.com>
                branch nick: bug_869_1
                timestamp: Wed 2012-02-01 11:19:53 +0530
                message:
                  BUG#11756869 - 48848: MYISAMCHK DOING SORT RECOVER IN CERTAIN
                                        CASES RESETS DATA POINTER TO SMAL
                  
                  ISSUE: Myisamchk doing sort recover
                         on a table reduces data_file_length.
                         Maximum size of data file decreases,
                         lesser number of rows are stored.
                  
                  SOLUTION: Size of data_file_length is
                            fixed to the original length.
            ------------------------------------------------------------
            revno: 2555.937.98
            committer: Inaam Rana <inaam.rana@oracle.com>
            branch nick: mysql-5.1
            timestamp: Tue 2012-01-31 09:31:31 -0500
            message:
              Bug#13636122 THE ORIGINAL TABLE MISSING WHILE EXECUTE THE DDL 'ALTER TABLE ADD COLUMN
              
              rb://914
              approved by: Marko Makela
              
              Poll in fil_rename_tablespace() after setting ::stop_ios flag can
              result in a hang because the other thread actually dispatching the IO
              won't wake IO helper threads or flush the tablespace before starting
              wait in fil_mutex_enter_and_prepare_for_io().
            ------------------------------------------------------------
            revno: 2555.937.97
            committer: sayantan.dutta@oracle.com
            branch nick: mysql-5.1
            timestamp: Tue 2012-01-31 17:39:40 +0530
            message:
              (no message)
            ------------------------------------------------------------
            revno: 2555.937.96
            committer: sayantan.dutta@oracle.com
            branch nick: mysql-5.1
            timestamp: Tue 2012-01-31 17:09:32 +0530
            message:
              Bug #64127: MTR --warnings option misses some of InnoDB errors and warnings
            ------------------------------------------------------------
            revno: 2555.937.95 [merge]
            committer: Ramil Kalimullin <ramil@mysql.com>
            branch nick: mysql-5.1
            timestamp: Tue 2012-01-31 10:57:12 +0400
            message:
              Null-merge from mysql-5.0.
                ------------------------------------------------------------
                revno: 1810.3999.18
                committer: Ramil Kalimullin <ramil@mysql.com>
                branch nick: mysql-5.0
                timestamp: Mon 2012-01-30 22:52:33 +0400
                message:
                  Fix for BUG#13596377: MYSQL CRASHES ON STARTUP ON FREEBSD IN PB2
                  
                  Fix for #36428/#38364 backported into 5.0.
            ------------------------------------------------------------
            revno: 2555.937.94
            committer: Guilhem Bichot <guilhem.bichot@oracle.com>
            branch nick: mysql-5.1
            timestamp: Thu 2012-01-26 10:25:23 +0100
            message:
              Fixes for:
              BUG#13519696 - 62940: SELECT RESULTS VARY WITH VERSION AND
              WITH/WITHOUT INDEX RANGE SCAN
              BUG#13453382 - REGRESSION SINCE 5.1.39, RANGE OPTIMIZER WRONG
              RESULTS WITH DECIMAL CONVERSION
              BUG#13463488 - 63437: CHAR & BETWEEN WITH INDEX RETURNS WRONG
              RESULT AFTER MYSQL 5.1.
              Those are all cases where the range optimizer got it wrong
              with > and >=.
            ------------------------------------------------------------
            revno: 2555.937.93
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Wed 2012-01-25 10:15:27 +0200
            message:
              btr_cur_search_to_nth_level(): Add a debug assertion
              and some Valgrind instrumentation.
            ------------------------------------------------------------
            revno: 2555.937.92 [merge]
            committer: Alexander Barkov <alexander.barkov@oracle.com>
            branch nick: mysql-5.1.b13458237
            timestamp: Tue 2012-01-24 16:02:12 +0400
            message:
              Merging from mysql-5.1
                ------------------------------------------------------------
                revno: 2555.950.1
                committer: Alexander Barkov <alexander.barkov@oracle.com>
                branch nick: mysql-5.1.b11752408
                timestamp: Mon 2012-01-23 13:07:10 +0400
                message:
                  Bug#11752408 - 43593: DUMP/BACKUP/RESTORE/UPGRADE TOOLS FAILS BECAUSE OF UTF8_GENERAL_CI
                  
                  Introducing new collations:
                  utf8_general_mysql500_ci and ucs2_general_mysql500_ci,
                  to reproduce behaviour of utf8_general_ci and ucs2_general_ci
                  from mysql-5.1.23 (and earlier).
                  
                  The collations are added to simplify upgrade from mysql-5.1.23 and earlier.
                  
                  Note: The patch does not make new server start over old data automatically.
                  Some manual upgrade procedures are assumed.
                  
                  Paul: please get in touch with me to discuss upgrade procedures
                  when documenting this bug.
                  
                  modified:
                    include/m_ctype.h
                    mysql-test/r/ctype_utf8.result
                    mysql-test/t/ctype_utf8.test
                    mysys/charset-def.c
                    strings/ctype-ucs2.c
                    strings/ctype-utf8.c
            ------------------------------------------------------------
            revno: 2555.937.91
            committer: Alexander Barkov <alexander.barkov@oracle.com>
            branch nick: mysql-5.1.b13458237
            timestamp: Tue 2012-01-24 13:00:13 +0400
            message:
              BUG#13458237 - INCONSISTENT HANDLING OF INVALIDE DATES WITH ZERO DAY. SIMILAR TO '2009-10-00' 
              - Reverting the patch for Bug # 12584302
                The patch will be reverted in 5.1 and 5.5.
                The patch will not be reverted in 5.6, the change will
                be properly documented in 5.6.
              - Backporting DBUG_ASSERT not to crash on '0000-01-00'
                (already fixed in mysql-trunk (5.6))
            ------------------------------------------------------------
            revno: 2555.937.90
            committer: Nirbhay Choubey <nirbhay.choubey@oracle.com>
            branch nick: mysql-5.1
            timestamp: Tue 2012-01-17 09:10:58 +0530
            message:
              Bug #11760384 52792: MYSQLDUMP IN XML MODE DOES NOT
                                   DUMP ROUTINES
              
              Minor post-fix to avoid build failure when built with
              Werror.
            ------------------------------------------------------------
            revno: 2555.937.89
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Mon 2012-01-16 14:22:03 +0200
            message:
              Bug#13496818 ASSERTION: REC_PAGE_NO > 4 IN IBUF CONTRACTION
              Relax a bogus debug assertion.
              Approved by Jimmy Yang on IM.
            ------------------------------------------------------------
            revno: 2555.937.88
            committer: Nuno Carvalho <nuno.carvalho@oracle.com>
            branch nick: mysql-5.1
            timestamp: Mon 2012-01-16 09:17:40 +0000
            message:
              BUG#11893288 60542: RPL.RPL_EXTRA_COL_MASTER_* DOESN'T TEST WHAT WAS INTENDED
              
              Test extra/rpl_tests/rpl_extra_col_master.test (used by
              rpl_extra_col_master_*) ends with the active connection pointing to the
              slave. Thus, the two last tests never succeed in changing the binlog
              format of the master away from 'row'. With correct active connection
              (master) tests fail for binlog 'statement' and 'mixed' formats.
              
              Tests rpl_extra_col_master_* only run when binary log format is
              row.  Statement and mix replication do not make sense in this
              tests since it will try to execute statements on columns that do
              not exist.  This fix is basically a backport from mysql-5.5, see
              changes done as part of BUG 39934.
            ------------------------------------------------------------
            revno: 2555.937.87
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Mon 2012-01-16 09:55:12 +0200
            message:
              buf_page_get_known_nowait(): Relax a bogus debug assertion.
              When mode==BUF_KEEP_OLD, buffered inserts are being merged to the page.
              It is possible that a read request for a page was pending while the page
              was freed in DROP INDEX or DROP TABLE. In these cases, it is OK (although
              useless) to merge the buffered changes to the freed page.
            ------------------------------------------------------------
            revno: 2555.937.86
            committer: Annamalai Gurusami <annamalai.gurusami@oracle.com>
            branch nick: mysql-5.1-bug11765438
            timestamp: Mon 2012-01-16 09:58:31 +0530
            message:
              Bug #11765438 58406: 
              ISSUES WITH COPYING PARTITIONED INNODB TABLES FROM LINUX TO WINDOWS
              
              This problem was already fixed in mysql-trunk as part of bug #11755924.  I am 
              backporting the fix to mysql-5.1.  
        ------------------------------------------------------------
        revno: 2555.949.9
        committer: Gopal Shankar <gopal.shankar@oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Mon 2012-01-30 11:57:33 +0530
        message:
                Bug#13105873 :Valgrind Warning: CRASH IN FOREIGN
                KEY HANDLING ON SUBSEQUENT CREATE TABLE IF NOT EXISTS
                
                PROBLEM:
                --------
                Consider a SP routine which does CREATE TABLE
                with REFERENCES clause. The first call to this routine
                invokes parser and the parsed items are cached, so as 
                to avoid parsing for the second execution of the routine.
                
                It is obsevered that valgrind reports a warning
                upon read of thd->lex->alter_info->key_list->Foreign_key object,
                which seem to be pointing to a invalid memory address
                during second time execution of the routine. Accessing this object
                theoretically could cause a crash.
                
                ANALYSIS:
                ---------
                The problem stems from the fact that for some reason
                elements of ref_columns list in thd->lex->alter_info->
                key_list->Foreign_key object are changed to point to
                objects allocated on runtime memory root.
                
                During the first execution of routine we create
                a copy of thd->lex->alter_info object.
                As part of this process we create a clones of objects in
                Alter_info::key_list and of Foreign_key object in particular.
                Then Foreign_key object is cloned for some reason we
                perform shallow copies of both Foreign_key::ref_columns
                and Foreign_key::columns list. So new instance of 
                Foreign_key object starts to SHARE contents of ref_columns
                and columns list with the original instance.
                After that as part of cloning process we call
                list_copy_and_replace_each_value() for elements of
                ref_columns list. As result ref_columns lists in both
                original and cloned Foreign_key object start to contain
                pointers to Key_part_spec objects allocated on runtime
                memory root because of shallow copy.
                
                So when we start copying of thd->lex->alter_info object
                during the second execution of stored routine we indeed
                encounter pointer to the Key_part_spec object allocated
                on runtime mem-root which was cleared during at the end
                of previous execution. This is done in sp_head::execute(), 
                by a call to free_root(&execute_mem_root,MYF(0));
                As result we get valgrind warnings about accessing 
                unreferenced memory.
                
                FIX:
                ----
                The safest solution to this problem is to 
                fix Foreign_key(Foreign_key, MEM_ROOT) constructor to do
                a deep copy of columns lists, similar to Key(Key, MEM_ROOT) 
                constructor.
        ------------------------------------------------------------
        revno: 2555.949.8
        committer: Tor Didriksen <tor.didriksen@oracle.com>
        branch nick: 5.1-security
        timestamp: Fri 2012-01-27 11:13:13 +0100
        message:
          Bug#13580775 ASSERTION FAILED: RECORD_LENGTH == M_RECORD_LENGTH
          Bug#13011410 CRASH IN FILESORT CODE WITH GROUP BY/ROLLUP
          
          The assert in 13580775 is visible in 5.6 only, 
          but shows that all versions are vulnerable.
          13011410 crashes in all versions.
          
          filesort tries to re-use the sort buffer between invocations in order to save
          malloc/free overhead.
          The fix for Bug 11748783 - 37359: FILESORT CAN BE MORE EFFICIENT.
          added an assert that buffer properties (num_records, record_length) are
          consistent between invocations. Indeed, they are not necessarily consistent.
            
          Fix: re-allocate the sort buffer if properties change.
        ------------------------------------------------------------
        revno: 2555.949.7 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Thu 2012-01-12 16:43:41 +0200
        message:
          empty weave merge mysql-5.0-security->mysql-5.1-security
            ------------------------------------------------------------
            revno: 1810.4002.30 [merge]
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: merge-5.0-security
            timestamp: Thu 2012-01-12 16:39:44 +0200
            message:
              empty weave merge from mysql-5.0
        ------------------------------------------------------------
        revno: 2555.949.6 [merge]
        committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
        branch nick: merge-5.1-security
        timestamp: Thu 2012-01-12 16:42:23 +0200
        message:
          weave merge mysql-5.1->mysql-5.1-security
            ------------------------------------------------------------
            revno: 2555.937.85 [merge]
            committer: Georgi Kodinov <Georgi.Kodinov@Oracle.com>
            branch nick: merge-5.1
            timestamp: Thu 2012-01-12 14:57:14 +0200
            message:
              empty weave merge
                ------------------------------------------------------------
                revno: 1810.3999.17 [merge]
                committer: Bjorn Munch <bjorn.munch@oracle.com>
                branch nick: mysql-5.0
                timestamp: Wed 2012-01-11 10:10:34 +0100
                message:
                  Merge from mysql-5.0.95-release
            ------------------------------------------------------------
            revno: 2555.937.84 [merge]
            committer: Karen Langford <karen.langford@oracle.com>
            branch nick: mysql-5.1
            timestamp: Wed 2012-01-11 18:51:42 +0100
            message:
              Merge from mysql-5.1.61-release
            ------------------------------------------------------------
            revno: 2555.937.83
            committer: Nirbhay Choubey <nirbhay.choubey@oracle.com>
            branch nick: mysql-5.1.52792
            timestamp: Tue 2012-01-10 13:33:45 +0530
            message:
              BUG#11760384 - 52792: mysqldump in XML mode does not dump
                                   routines.
              
              mysqldump in xml mode did not dump routines, events or
              triggers.
              
              This patch fixes this issue by fixing the if conditions
              that disallowed the dump of above mentioned objects in
              xml mode, and added the required code to enable dump
              in xml format.
            ------------------------------------------------------------
            revno: 2555.937.82
            committer: Yasufumi Kinoshita <yasufumi.kinoshita@oracle.com>
            branch nick: mysql-5.1
            timestamp: Tue 2012-01-10 14:18:58 +0900
            message:
              Bug#12400341 INNODB CAN LEAVE ORPHAN IBD FILES AROUND
              
              If we meet DB_TOO_MANY_CONCURRENT_TRXS during the execution tab_create_graph from row_create_table_for_mysql(), .ibd file for the table should be created already but was not deleted for the error handling.
              
              rb:875 approved by Jimmy Yang
            ------------------------------------------------------------
            revno: 2555.937.81
            committer: Hemant Kumar <hemant.hk.kumar@oracle.com>
            branch nick: mysql-5.1
            timestamp: Fri 2012-01-06 16:28:24 +0530
            message:
              Bug#12872803 - 62154: FEDERATED.FEDERATED_SERVER TEST FAILS WITH RUN --REPEAT=2
              Fixed it to work with "--repeat" option.
            ------------------------------------------------------------
            revno: 2555.937.80
            committer: Hemant Kumar <hemant.hk.kumar@oracle.com>
            branch nick: mysql-5.1
            timestamp: Fri 2012-01-06 15:46:03 +0530
            message:
              Bug#12872804 - 62155: BINLOG.BINLOG_STM_UNSAFE_WARNING FAILS WHEN RUN WITH --REPEAT=2
              Fixed the testcase using timestamp logic while doing grep from the error file.
            ------------------------------------------------------------
            revno: 2555.937.79
            committer: Tatjana Azundris Nuernberg <tatjana.nuernberg@oracle.com>
            branch nick: 51-11755281
            timestamp: Mon 2012-01-02 06:25:48 +0000
            message:
              BUG#11755281/47032: ERROR 2006 / ERROR 2013 INSTEAD OF PROPER ERROR MESSAGE
              
              If init_command was incorrect, we couldn't let users execute
              queries, but we couldn't report the issue to the client either
              as it does not expect error messages before even sending a
              command. Thus, we simply disconnected them without throwing
              a clear error.
              
              We now go through the proper sequence once (without executing
              any user statements) so we can report back what the problem
              is. Only then do we disconnect the user.
              
              As always, root remains unaffected by this as init_command is
              (still) not executed for them.
            ------------------------------------------------------------
            revno: 2555.937.78
            committer: Marko M?kel? <marko.makela@oracle.com>
            branch nick: mysql-5.1
            timestamp: Wed 2011-12-28 12:19:30 +0200
            message:
              Bug#13418934 REMOVE HAVE_PURIFY DEPENDENCES FROM INNODB
              
              InnoDB: Remove HAVE_purify, UNIV_INIT_MEM_TO_ZERO, UNIV_SET_MEM_TO_ZERO.
              
              The compile-time setting HAVE_purify can mask potential bugs.
              It is being set in PB2 Valgrind runs. We should simply get rid of it,
              and replace it with UNIV_MEM_INVALID() to declare uninitialized memory
              as such in Valgrind-instrumented binaries.
              
              os_mem_alloc_large(), ut_malloc_low(): Remove the parameter set_to_zero.
              
              ut_malloc(): Define as a macro that invokes ut_malloc_low().
              
              buf_pool_init(): Never initialize the buffer pool frames. All pages
              must be initialized before flushing them to disk.
              
              mem_heap_alloc(): Never initialize the allocated memory block.
              
              os_mem_alloc_nocache(), ut_test_malloc(): Unused function, remove.
              
              rb:813 approved by Jimmy Yang
            ------------------------------------------------------------
            revno: 2555.937.77
            committer: Ramil Kalimullin <ramil@mysql.com>
            branch nick: mysql-5.1
            timestamp: Fri 2011-12-23 18:52:44 +0400
            message:
              Fix for bug#11758931 - 51196: SLAVE SQL: GOT AN ERROR WRITING
              COMMUNICATION PACKETS, ERROR_CODE: 1160
              
              Addendum: for some queries table->in_use might be NULL -
              check it.
            ------------------------------------------------------------
            revno: 2555.937.76
            committer: Ramil Kalimullin <ramil@mysql.com>
            branch nick: mysql-5.1
            timestamp: Fri 2011-12-23 17:22:48 +0400
            message:
              Fix for bug#11758931 - 51196: SLAVE SQL: GOT AN ERROR WRITING 
              COMMUNICATION PACKETS, ERROR_CODE: 1160
              
              If idle FEDERATED table is evicted from the table cache when 
              a connection to remote server is lost, query that initiated 
              eviction may fail.
              If this query is executed by slave SQL thread it may fail as well.
              
              An error of close was stored in diagnostics area, which was later
              attributed to the statement that caused eviction.
              
              With this patch FEDERATED clears an error of close.
            ------------------------------------------------------------
            revno: 2555.937.75
            committer: Inaam Rana <inaam.rana@oracle.com>
            branch nick: mysql-5.1
            timestamp: Wed 2011-12-21 21:36:52 -0500
            message:
              Add ChangeLog message.
            ------------------------------------------------------------
            revno: 2555.937.74
            committer: Inaam Rana <inaam.rana@oracle.com>
            branch nick: mysql-5.1
            timestamp: Wed 2011-12-21 21:33:13 -0500
            message:
              Bug#11866367	FPE WHEN SETTING INNODB_SPIN_WAIT_DELAY
              
              rb://865
              approved by: Jimmy
              
              Integer overflow causes division by zero.
        ------------------------------------------------------------
        revno: 2555.949.5
        committer: Jon Olav Hauglid <jon.hauglid@oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Mon 2012-01-09 11:28:02 +0100
        message:
          Backport from mysql-trunk of:
          ------------------------------------------------------------
          revno: 3258
          committer: Jon Olav Hauglid <jon.hauglid@oracle.com>
          branch nick: mysql-trunk-bug12663165
          timestamp: Thu 2011-07-14 10:05:12 +0200
          message:
            Bug#12663165 SP DEAD CODE REMOVAL DOESN'T UNDERSTAND CONTINUE HANDLERS
            
            When stored routines are loaded, a simple optimizer tries to locate
            and remove dead code. The problem was that this dead code removal
            did not work correctly with CONTINUE handlers.
            
            If a statement triggers a CONTINUE handler, the following statement
            will be executed after the handler statement has completed. This
            means that the following statement is not dead code even if the
            previous statement unconditionally alters control flow. This fact
            was lost on the dead code removal routine, which ended up with
            removing instructions that could have been executed. This could
            then lead to assertions, crashes and generally bad behavior when
            the stored routine was executed.
            
            This patch fixes the problem by marking as live code all stored
            routine instructions that are in the same scope as a CONTINUE handler.
            
            Test case added to sp.test.
        ------------------------------------------------------------
        revno: 2555.949.4
        committer: Vasil Dimov <vasil.dimov@oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Thu 2011-12-22 12:55:44 +0200
        message:
          Fix Bug#13510739 63775: SERVER CRASH ON HANDLER READ NEXT AFTER DELETE RECORD.
          
          CREATE TABLE bug13510739 (c INTEGER NOT NULL, PRIMARY KEY (c)) ENGINE=INNODB;
          INSERT INTO bug13510739 VALUES (1), (2), (3), (4);
          DELETE FROM bug13510739 WHERE c=2;
          HANDLER bug13510739 OPEN;
          HANDLER bug13510739 READ `primary` = (2);
          HANDLER bug13510739 READ `primary` NEXT;  <-- crash
          
          The bug is that in the particular testcase row_search_for_mysql() picked up
          a delete-marked record and quit, leaving the cursor non-positioned state and
          on the subsequent 'get next' call the code crashed because of the
          non-positioned cursor.
          
          In row0sel.cc (line numbers from mysql-trunk):
          
          4653         if (rec_get_deleted_flag(rec, comp)) {
          ...
          4679                 if (index == clust_index && unique_search) {
          4680 
          4681                         err = DB_RECORD_NOT_FOUND;
          4682                         
          4683                         goto normal_return;
          4684                 }       
          
          it quit from here, not storing the cursor position.
          
          In contrast, if the record=2 is not found at all (e.g. sleep(1) after DELETE
          to let the purge wipe it away completely) then 'get = 2' does find record=3
          and quits from here:
          
          4366                 if (0 != cmp_dtuple_rec(search_tuple, rec, offsets)) {
          ...
          4394                         btr_pcur_store_position(pcur, &mtr);
          4395 
          4396                         err = DB_RECORD_NOT_FOUND;
          4397 #if 0
          4398                         ut_print_name(stderr, trx, FALSE, index->name);
          4399                         fputs(" record not found 3\n", stderr);
          4400 #endif
          4401 
          4402                         goto normal_return;
          
          Another fix could be to extend the condition on line 4366 to hold only if
          seach_tuple matches rec AND if rec is not delete marked.
          
          Notice that in the above test case if we wait about 1 second somewhere after
          DELETE and before 'get = 2', then the testcase does not crash and returns 4
          instead. Not sure if this is the correct behavior, but this bugfix removes
          the crash and makes the code return what it also returns in the non-crashing
          case (if rec=2 is not found during 'get = 2', e.g. we have sleep(1) there).
          
          Approved by:	Marko (http://bur03.no.oracle.com/rb/r/863/)
        ------------------------------------------------------------
        revno: 2555.949.3 [merge]
        committer: Joerg Bruehe <joerg.bruehe@oracle.com>
        branch nick: security-5.1
        timestamp: Fri 2011-12-16 12:54:28 +0100
        message:
          Empty merge (alignment of version number changesets).
            ------------------------------------------------------------
            revno: 1810.4002.29 [merge]
            committer: Joerg Bruehe <joerg.bruehe@oracle.com>
            branch nick: security-5.0
            timestamp: Fri 2011-12-16 12:51:47 +0100
            message:
              Empty merge of identical version number changes.
            ------------------------------------------------------------
            revno: 1810.4002.28
            author: joerg.bruehe@oracle.com
            committer: Build Team <MYSQL-RE_WW@oracle.com>
            branch nick: mysql-5.0-security
            timestamp: Fri 2011-12-16 12:22:47 +0100
            message:
              Raise version number after cloning 5.0.95
        ------------------------------------------------------------
        revno: 2555.949.2 [merge]
        committer: Joerg Bruehe <joerg.bruehe@oracle.com>
        branch nick: security-5.1
        timestamp: Fri 2011-12-16 12:50:07 +0100
        message:
          Empty merge of version number changes.
            ------------------------------------------------------------
            revno: 2555.937.73 [merge]
            committer: Joerg Bruehe <joerg.bruehe@oracle.com>
            branch nick: mysql-5.1
            timestamp: Fri 2011-12-16 12:39:10 +0100
            message:
              Empty upmerge of a 5.0 version number increase.
                ------------------------------------------------------------
                revno: 1810.3999.16
                committer: Joerg Bruehe <joerg.bruehe@oracle.com>
                branch nick: mysql-5.0
                timestamp: Fri 2011-12-16 12:33:54 +0100
                message:
                  Raise version number after cloning 
            ------------------------------------------------------------
            revno: 2555.937.72
            committer: Joerg Bruehe <joerg.bruehe@oracle.com>
            branch nick: mysql-5.1
            timestamp: Fri 2011-12-16 12:31:57 +0100
            message:
              Raise version number after cloning 
        ------------------------------------------------------------
        revno: 2555.949.1
        author: joerg.bruehe@oracle.com
        committer: Build Team <MYSQL-RE_WW@oracle.com>
        branch nick: mysql-5.1-security
        timestamp: Fri 2011-12-16 12:24:05 +0100
        message:
          Raise version number after cloning 5.1.61
------------------------------------------------------------
revno: 4559 [merge]
committer: Pekka Nousiainen <pekka.nousiainen@oracle.com>
branch nick: ms-bug13881465-71
timestamp: Tue 2012-06-05 15:13:58 +0300
message:
  merge 7.0->7.1
    ------------------------------------------------------------
    revno: 3362.176.22
    committer: Pekka Nousiainen <pekka.nousiainen@oracle.com>
    branch nick: ms-bug13881465-70
    timestamp: Tue 2012-06-05 14:49:49 +0300
    message:
      bug#13881465 a01_tool.diff
      ndb_blob_tool: blob repair (delete orphans)
------------------------------------------------------------
revno: 4558
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Mon 2012-06-04 11:08:48 -0700
message:
  Restore QueryUniqueKeyTest but leave it disabled
------------------------------------------------------------
revno: 4557
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Sun 2012-06-03 19:39:24 -0700
message:
  Disable QueryUniqueKeyTest
------------------------------------------------------------
revno: 4556
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Sun 2012-06-03 18:53:51 -0700
message:
  Disable uniqueKeyBetweenQuery
------------------------------------------------------------
revno: 4555
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-05-31 14:25:40 -0700
message:
  Disable query limits test
------------------------------------------------------------
revno: 4554
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-05-31 13:42:32 -0700
message:
  Set scan options and scan flags only if needed
------------------------------------------------------------
revno: 4553 [merge]
committer: Frazer Clement <frazer.clement@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-05-31 15:56:01 +0100
message:
  Merge 7.0->7.1
    ------------------------------------------------------------
    revno: 3362.176.21
    committer: Frazer Clement <frazer.clement@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Thu 2012-05-31 15:42:04 +0100
    message:
      Bug#14083116 (Bad error handling in LQH corrupts transid hash)
      
      Early exits when processing LQHKEYREQ signals could result in 
      corruption of the LQH transid hash, due to the wrong error handling
      path being used.
      
      This patch fixes the early exits, and adds assertions to the transid
      hash code to help catch such problems quicker in future.
      
      Testcase to be added on merge to cluster-7.2.
------------------------------------------------------------
revno: 4552
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-05-31 07:16:36 -0700
message:
  Disable query ordering tests
------------------------------------------------------------
revno: 4551
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Wed 2012-05-30 17:47:21 -0700
message:
  Add query ordering to clusterj.
  Add setOrdering(Order, String[]) to Query.
  If ordering is specified, there must be an index that contains all ordering fields.
  Filters with "in" with ordering fields will use multiple range scan and
  each range is ordered independently.
------------------------------------------------------------
revno: 4550 [merge]
committer: Frazer Clement <frazer.clement@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Tue 2012-05-29 18:07:42 +0100
message:
  Merge 7.0->7.1
    ------------------------------------------------------------
    revno: 3362.176.20
    committer: Frazer Clement <frazer.clement@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Tue 2012-05-29 18:04:36 +0100
    message:
      Bug #14075825 LCP Watchdog : Fragment scan check - use specific error
      
      This patch extends the previous patch implementing the 
      LCP Fragment scan watchdog.
      
      This patch adds a specific ndbd/mtd process return code for the
      LCP Fragment scan watchdog failure scenario.
      
      This can allow external monitoring frameworks to detect this scenario
      at the process execution level and take specific steps. 
------------------------------------------------------------
revno: 4549
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Thu 2012-05-24 06:50:07 -0700
message:
  Fix SF_OrderBy setting for clusterj
------------------------------------------------------------
revno: 4548
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Wed 2012-05-23 23:39:40 -0700
message:
  Set SF_OrderBy scan flags to guarantee ordered scans
------------------------------------------------------------
revno: 4547
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Wed 2012-05-23 16:51:17 -0700
message:
  Add limits api to clusterj.
  Query.setLimits(long skip, long limit) can be used to limit query results.
  Skip is the number of records to skip. Limit is the number of records to return.
  Limits cannot be used for deletePersistentAll. 
  Records skipped and records not returned after the limit is reached
  are not locked.
------------------------------------------------------------
revno: 4546 [merge]
committer: magnus.blaudd@oracle.com
branch nick: 7.1
timestamp: Wed 2012-05-23 14:36:54 +0200
message:
  Merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.19
    committer: magnus.blaudd@oracle.com
    branch nick: 7.0
    timestamp: Wed 2012-05-23 14:31:34 +0200
    message:
      Bug#14106592 DEBUG BUILD CRASH IN NDB_SERIALIZE_COND()
       - Use Item::print to print the value of Item_* to String
       before printing to DBUG log
      - NOTE! 7.2 has one more place which need same fix
    ------------------------------------------------------------
    revno: 3362.176.18
    committer: magnus.blaudd@oracle.com
    branch nick: 7.0
    timestamp: Wed 2012-05-23 13:45:13 +0200
    message:
      Bug#14107173 CONNECT WITH TIMEOUT DOES NOT SET SOCKET BACK TO BLOCKING
       - Set socket back to blocking mode after connect finish
------------------------------------------------------------
revno: 4545 [merge]
committer: Frazer Clement <frazer.clement@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Mon 2012-05-21 23:44:16 +0100
message:
  Merge 7.0->7.1
    ------------------------------------------------------------
    revno: 3362.176.17
    committer: Frazer Clement <frazer.clement@oracle.com>
    branch nick: mysql-5.1-telco-7.0
    timestamp: Mon 2012-05-21 23:27:28 +0100
    message:
      Bug #14075825 LCP Watchdog : Fragment scan check
      
      The Local Checkpoint (LCP) mechanism allows Ndb to trim its redo and
      undo logs.  This keeps node and system recovery time within bounds, 
      and maintains free redo and undo space to support logging DML 
      operations. 
       
      A watchdog mechanism is added to supervise fragment scans occurring
      as part of a local checkpoint.  This is intended to guard against any
      scan related OS level IO errors or bugs causing issues with LCP and 
      endangering write service and recovery times.
      
      Each node independently monitors the progress of local fragment 
      scans occurring as part of an LCP.  If no progress is made for 
      20 seconds, warning logs will be generated every 10 seconds.  
      If no progress is made for one minute then the fragment scan is 
      considered to be hung, and the node will be restarted to enable 
      LCP to continue. 
      
      Any occurrence of warning logs or other action taken by this 
      watchdog should be reported as a bug.
      
      A new test scenario is added to testNodeRestart. 
------------------------------------------------------------
revno: 4544 [merge]
committer: Martin Zaun <martin.zaun@oracle.com>
branch nick: ndb-7.1
timestamp: Wed 2012-05-16 18:45:28 -0700
message:
  merge from ndb-7.1-ndbjtie-minor-fixes
    ------------------------------------------------------------
    revno: 4542.1.1
    committer: Martin Zaun <martin.zaun@oracle.com>
    branch nick: ndb-7.1-ndbjtie-minor-fixes
    timestamp: Wed 2012-05-16 18:36:46 -0700
    message:
      ndbjtie - fixed minor mapping bug (ByteBuffer instead of int[])
------------------------------------------------------------
revno: 4543
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Wed 2012-05-16 17:19:25 -0700
message:
  Fix bug in NdbRecord index scans where the buffers used in IndexBound were not strongly held.
  This allowed garbage collection to reuse the buffers before the index scan operation was defined.
  The result was that the index scan operation was defined with incorrect bounds, 
  which led to incorrect results, but also could have resulted in reading uninitialized memory.
------------------------------------------------------------
revno: 4542 [merge]
committer: magnus.blaudd@oracle.com
branch nick: 7.1
timestamp: Mon 2012-05-07 09:49:18 +0200
message:
  Merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.16 [merge]
    committer: magnus.blaudd@oracle.com
    branch nick: mysql-5.1-telco-7.0
    timestamp: Mon 2012-05-07 09:44:30 +0200
    message:
      Merge
        ------------------------------------------------------------
        revno: 3362.178.4
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Mon 2012-05-07 09:38:13 +0200
        message:
          ndb
           - Change server part of SocketAuthenticator no to save
             the username or password. Fortunately neither username or password are
             checked to this is not a serious problem yet.
           - Remove useless casts
           - Improve comments
           - Remove use of magic constants and replace them with sizeof()
        ------------------------------------------------------------
        revno: 3362.178.3
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Tue 2012-04-24 10:33:27 +0200
        message:
          ndb
           - remove unused member variables createIndex, remoteHostAddress and
           localHostAddress from Transporter
        ------------------------------------------------------------
        revno: 3362.178.2
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Mon 2012-04-23 21:00:46 +0200
        message:
          ndb - fix spelling error
        ------------------------------------------------------------
        revno: 3362.178.1
        committer: magnus.blaudd@oracle.com
        branch nick: 7.0
        timestamp: Mon 2012-04-23 10:11:54 +0200
        message:
          ndb_connect
           - remove usage of gptr
           - change the faulty ndb_desc strings to ndb_connect
    ------------------------------------------------------------
    revno: 3362.176.15 [merge]
    committer: Pekka Nousiainen <pekka.nousiainen@oracle.com>
    branch nick: ms-bug13834481-70
    timestamp: Thu 2012-05-03 12:54:05 +0300
    message:
      merge
        ------------------------------------------------------------
        revno: 2585.187.11
        committer: Pekka Nousiainen <pekka.nousiainen@oracle.com>
        branch nick: ms-bug13834481-63
        timestamp: Thu 2012-05-03 12:52:53 +0300
        message:
          bug#13834481 b01_upg.diff
          testUpgrade failing before 7.0 patches
    ------------------------------------------------------------
    revno: 3362.176.14
    committer: Pekka Nousiainen <pekka.nousiainen@oracle.com>
    branch nick: ms-bug13834481-70
    timestamp: Thu 2012-05-03 12:49:00 +0300
    message:
      bug#13834481 a03_fix.diff
      TC(6.3)->LQH(7.x) hashHi caused timeout
    ------------------------------------------------------------
    revno: 3362.176.13
    committer: Pekka Nousiainen <pekka.nousiainen@oracle.com>
    branch nick: ms-bug13834481-70
    timestamp: Thu 2012-05-03 12:48:34 +0300
    message:
      bug#13834481 a02_fix.diff
      clear attrLen to avoid interpret as 7.x bits
    ------------------------------------------------------------
    revno: 3362.176.12
    committer: Pekka Nousiainen <pekka.nousiainen@oracle.com>
    branch nick: ms-bug13834481-70
    timestamp: Thu 2012-05-03 12:47:51 +0300
    message:
      bug#13834481 a01_fix.diff
      TC(7.x)->LQH(6.3) missing shift caused 1231
------------------------------------------------------------
revno: 4541
committer: Craig L Russell <Craig.Russell@oracle.com>
branch nick: mysql-5.1-telco-7.1
timestamp: Sun 2012-05-06 06:55:09 -0700
message:
  Improve life cycle of IndexBound, NdbInterpretedCode, NdbScanFilter, and NdbScanOptions
  create and delete these objects in DbImpl (associated with the Ndb object)
  delete these objects after the transaction.execute call
  clean up these objects if an exception is thrown before the execute call
  at Db.close, verify that the count of created and deleted objects matches
  if mismatch, log a warning
------------------------------------------------------------
revno: 4540 [merge]
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1_tag
timestamp: Mon 2012-04-30 07:40:59 +0200
message:
  Setting ndb version to 7.1.23
    ------------------------------------------------------------
    revno: 3362.176.11
    committer: Martin Skold <Martin.Skold@oracle.com>
    branch nick: mysql-5.1-telco-7.0_tag
    timestamp: Mon 2012-04-30 07:37:14 +0200
    message:
      Setting ndb version to 7.0.34
------------------------------------------------------------
revno: 4539 [merge]
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1_tag
timestamp: Mon 2012-04-30 07:13:39 +0200
message:
  Merge
    ------------------------------------------------------------
    revno: 3362.176.10
    committer: Martin Skold <Martin.Skold@oracle.com>
    branch nick: mysql-5.1-telco-7.0_tag
    timestamp: Fri 2012-04-27 17:29:14 +0200
    message:
      Tagged mysql-5.1.61-ndb-7.0.33
------------------------------------------------------------
revno: 4538
committer: Martin Skold <Martin.Skold@oracle.com>
branch nick: mysql-5.1-telco-7.1_tag
timestamp: Mon 2012-04-30 07:06:47 +0200
message:
  Tagged mysql-5.1.61-ndb-7.1.22
------------------------------------------------------------
revno: 4537 [merge]
tags: clone-mysql-5.1.61-ndb-7.1.22-src-build
committer: Mauritz Sundell <mauritz.sundell@oracle.com>
branch nick: mysql-5.1-telco-7.1-debug
timestamp: Thu 2012-04-26 13:45:28 +0200
message:
  merge 7.0 -> 7.1
    ------------------------------------------------------------
    revno: 3362.176.9
    tags: clone-mysql-5.1.61-ndb-7.0.33-src-build
    committer: Mauritz Sundell <mauritz.sundell@oracle.com>
    branch nick: mysql-5.1-telco-7.0-bug14000373
    timestamp: Thu 2012-04-26 12:33:16 +0200
    message:
      ndb - bug#14000373, reintroduce 64K limit on hash index pages (~45Mrows)
      
      bug#13844405 should be reopened
